///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Common/AssemblyHelper/ILFetcher.h 3     5/10/06 8:02p Eaddy $
//
//    File name:	ILFetcher.h
//   Created By:	Marc Eaddy
//   Created on:	04/21/06
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Common/AssemblyHelper/ILFetcher.h $
 * 
 * 3     5/10/06 8:02p Eaddy
 * o Closer to multiple weaving
 * 
 * 2     5/03/06 8:15p Eaddy
 * o Now allows IMetaDataImport to come from Wicca
 * 
 * 1     4/22/06 12:35p Eaddy
 * o Adding support for using the Debugger API to query for the current
 * metadata and IL
 */

#ifndef INCLUDED_IL_FETCHER_H
#define INCLUDED_IL_FETCHER_H

#include <cor.h>                // CorElementType, mdMethodDef, etc.

#include <cordebug.h>           // ICorDebugModule

class CILFetcher
{
public:
    CILFetcher();

    HRESULT init(ICorDebugModule* piCorDebugModule);
    HRESULT init(LPCBYTE const pbMapViewOfFile, bool bIsImage);

    HRESULT GetMethodPtrInfo(   /*[in]*/ ULONG methodRVA,
                                /*[in]*/ mdMethodDef methodDef,
							    /*[out]*/ ULONG* pulMethodSize,
							    /*[out]*/ unsigned __int8** ppbMethodHeader,
							    /*[out]*/ ULONG* pulMethodHeaderSize,
							    /*[out]*/ LPCBYTE* ppbMethodIL,
							    /*[out]*/ ULONG* pulCodeSize,
							    /*[out]*/ mdSignature* ptokLocalVarSig,
                                /*[out]*/ bool* pbMustDeleteHeader) const;

private: // NOT IMPLEMENTED
    CILFetcher(const CILFetcher& that);
    CILFetcher& operator=(const CILFetcher& that);

private: // DATA
    CComPtr<ICorDebugModule> spiCorModule;
    LPCBYTE pbMapViewOfFile;
	bool bIsImage;
};

 HRESULT GetMethodIL(	/*[in]*/  unsigned __int8* const pbMethodHeader,
						/*[out]*/ ULONG* pulMethodSize,
						/*[out]*/ ULONG* pulHeaderSize,
						/*[out]*/ LPCBYTE* ppbMethodIL,
						/*[out]*/ ULONG* pulCodeSize,
						/*[out]*/ mdSignature* ptokLocalVarSig);

#endif // INCLUDED_IL_FETCHER_H
