///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/IlxContextImpl.cpp,v 1.1 2004/09/07 06:10:50 me133 Exp $
//
//    File name:	IlxContextImpl.cpp
//   Created By:	Marc Eaddy
//   Created On:	04/09/2002 3:49:57 PM
//
//      Purpose:	
//
//  Description:	XML is case-sensitive!
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: IlxContextImpl.cpp,v $
 * Revision 1.1  2004/09/07 06:10:50  me133
 * o Initial checkin to CVS
 * 
 * 
 * 34    8/19/02 6:59p Marce
 * o Now checks to see if the output string is empty
 * 
 * 33    7/31/02 8:58p Marce
 * o Now passes "Reason" to OnSetContext (Merged from 3.0)
 * 
 * 30    7/26/02 2:51p Marce
 * o Trivial change
 * 
 * 29    6/20/02 1:00p Marce
 * o Better handling of "file not found" errors. Its not an error if the
 * wsp was just upgraded.
 * 
 * 28    6/04/02 8:21p Marce
 * o Now CContextCallback also keeps track of which context properties
 * were modified by SetContextToXml()
 * o Moved implementation of CContextCallback into cpp file
 * 
 * 27    5/31/02 6:33p Marce
 * o Can now specify "UpdateOnly" instead of "UpdateOnly=Y"
 * o Fixed log message error
 * 
 * 26    5/31/02 1:04p Marce
 * o Added HasContextProperties()
 * o Fixed bug where we could go into an infinite loop
 * o Fixed bug where we we getting the Context element not the Prop
 * elements
 * 
 * 25    5/30/02 3:39p Marce
 * o Fixed bug in the default constructor where bUpdateOnly was a garbage
 * value since it doesn't get initialized
 * 
 * 24    5/21/02 11:43a Marce
 * o Now allows an xml formatted string to be passed to
 * GetContextFromXml()
 * o Added comments
 * 
 * 23    5/16/02 6:17p Marce
 * o If you want to find out if a property exists you don't have to
 * specify a result variant in GetContext2.  It returns S_OK if the
 * property exists and S_FALSE otherwise.
 * 
 * 22    5/16/02 5:36p Marce
 * o Fixed bug where typing in a symbol in News caused a double navigate
 * 
 * 21    5/06/02 12:17p Marce
 * o Kludge: Fixed bug where we get an access violation when accessing an
 * IXMLDOMDocument that has been marshalled and queued. The kludge is to
 * copy the document before accessing it.
 * 
 * 20    5/03/02 11:18a Marce
 * o BeforeSetContext was somehow messing up the heap because it was
 * calling VariantChangeType() on the variant passed in via the
 * marshaller.  It was causing a variant that was five levels up the call
 * stack to change.
 * o Lesson learned: Don't call VariantChangeType() directly on a variant
 * that's been passed to you by scripting or the marshaller!
 * 
 * 19    5/02/02 12:46p Marce
 * o Fixed link error
 * 
 * 18    5/02/02 12:40p Marce
 * o Made helper functions static
 * 
 * 17    5/02/02 12:37p Marce
 * o Made some functions public
 * 
 * 16    4/30/02 9:48p Marce
 * o Added support for UrlQuery so that all values are url canonicalized
 * 
 * 15    4/30/02 8:51p Marce
 * o Now GetContextFromXml() supports passing an XML string for the
 * context
 * 
 * 14    4/30/02 8:45p Marce
 * o Implemented saving context to a file path
 * o Now longer need to expose LoadContext() and SaveContext()
 * o Fixed bug where SetContextAttribute wasn't returning S_FALSE when the
 * new value was the same
 * o Now supports specifying an XML string for SetContextToXml()
 * o Now supports IILXProperties in SetContextToXml()
 * o Now calls the callback function when loading properties
 * 
 * 13    4/30/02 10:57a Marce
 * o Fixed link error
 * 
 * 12    4/27/02 2:16a Marce
 * o Created a callback interface to allow C++ clients (controls) to be
 * notified before and after a context property changes
 * o Fixed bug when SetContextToXml couldn't unpack an IXMLDOMDocument2
 * o Fixed bug where we weren't returning S_FALSE if the property value
 * didn't change
 * o Fixed trigraph sequences '???' that I accidentally used in some print
 * statements
 * o Made enumerations global so we don't have to scope them with the
 * namespace
 * 
 * 11    4/25/02 2:41a Marce
 * o No longer logs all Get and Sets
 * 
 * 10    4/25/02 2:17a Marce
 * o Was inadvertantly creating temporary CComBSTRs
 * 
 * 9     4/25/02 2:01a Marce
 * o LoadContext() no longer trashes the previous context
 * 
 * 8     4/25/02 1:02a Marce
 * o Now longer sets empty <PROP> elements
 * o Fixed bug where context properties were being removed by accident
 * 
 * 7     4/24/02 10:13p Marce
 * o Added support for NoPersist
 * o Added GetContext2Impl() and SetContext2Impl()
 * o Fixed bug when removing the first property
 * 
 * 6     4/24/02 6:21p Marce
 * o Added preliminary code for supporting saving/load XML nodes
 * o Created more generic RemoveContextProperty()
 * o Now supports Action=remove and Action=removeattribute
 * o Now also removes whitespace when removing a property node
 * 
 * 5     4/23/02 4:33p Marce
 * o Now supports removing all properties
 * 
 * 4     4/23/02 4:05p Marce
 * o Changed some constant and enumeration names
 * o Separated Action from Reason in CContextOptions
 * o Added comments, cleaned up file, reordered and removed functions
 * o Implemented SetContexts2()
 * o Fixed several bugs
 * 
 * 3     4/17/02 12:22p Marce
 * o SetContext2 now requires the varOptions parameter
 * o Added strings for all the possible Reasons
 * o Now supports GetContext2(empty,empty) to return full XML document
 * 
 * 2     4/16/02 9:08p Marce
 * o Now implements most of the new Context API
 * o Added comments
 * 
 * 1     4/11/02 12:24p Marce
 */

#include "StdAfx.h"

#include "IlxContextImpl.h"	// Me

#include "IlxLogHelper.h"	// Logging macros

#include "XmlHelpers2.h"	// AppendWhiteSpace();

#include "StringParsing.h"	// DelimitedString2StringList()

#include "IlxCommon.h"		// IILXProperties

#include <wininet.h>		// InternetCanonicalizeUrl()

// IXMLDOMDocument2 is defined in the msxml3.dll type library.  However,
// when I attempted to #import the type library I received a comdat
// duplicate symbol error (_IID_IXMLDOMNode).  I all really need is the
// IXMLDOMDocument2 interface so I copied it from msxml3.tlh.

namespace MSXML3
{
	struct __declspec(uuid("2933bf95-7b36-11d2-b20e-00c04f983e60"))
	IXMLDOMDocument2 : MSXML::IXMLDOMDocument
	{
		STDMETHOD(get_namespaces)(struct IXMLDOMSchemaCollection** namespaceCollection );
		STDMETHOD(get_schemas)(VARIANT* otherCollection);
		STDMETHOD(putref_schemas)(VARIANT otherCollection);
		STDMETHOD(validate)(struct IXMLDOMParseError** errorObj);
		STDMETHOD(setProperty)(BSTR name, VARIANT value);
		STDMETHOD(getProperty)(BSTR name, VARIANT* value);
	};

	extern "C" const GUID __declspec(selectany) IID_IXMLDOMDocument2 =
		{0x2933bf95,0x7b36,0x11d2,{0xb2,0x0e,0x00,0xc0,0x4f,0x98,0x3e,0x60}};
}

using namespace MSXML;

// HELPER FUNCTIONS

static HRESULT GetContextObjectFromVariant(	VARIANT* pvarContext, 
											IUnknown** ppiUnkContext, 
											BSTR* pbstrContext,
											IXMLDOMDocument** ppiXmlDoc);
	//
	// Helper function for extracting either an IUnknown* or BSTR
	// from a variant.
	//

static HRESULT InitializeContextDocument(MSXML::IXMLDOMDocument* piXmlDoc);
	//
	// Adds the top-level <CONTEXT> element.
	//

static HRESULT FindContextProperty(	/*[in]*/ MSXML::IXMLDOMDocument* piXmlDoc,
									/*[in]*/ BSTR bstrPropertyName,
									/*[out]*/ MSXML::IXMLDOMElement** ppiFoundPropElement);
	//
	// Finds a context property.
	//
	// *ppiFoundPropElement will contain the property if its found and S_OK will
	// be returned.  Otherwise, *ppiFoundPropElement will be 0 and S_FALSE will
	// be returned.
	//

static HRESULT SetContextAttribute(		MSXML::IXMLDOMDocument* piXmlDoc,
										CContextCallback* pContextCallback,
										const CContextOptions& options,
										BSTR bstrPropertyName,
										BSTR bstrAttributeName,
										VARIANT varAttributeValue);

static HRESULT SetContextProperty(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
									/*[in]*/ CContextCallback* pContextCallback,
									/*[in]*/ IXMLDOMElement* piSourceElement,
									/*[in]*/ const CContextOptions& options);

static HRESULT SetContextToXmlFromString(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
											/*[in]*/ CContextCallback* pContextCallback,
											/*[in]*/ BSTR bstrContextPropertyNames,
											/*[in]*/ const CContextOptions& options,
											/*[in]*/ VARIANT varValue);

static HRESULT SetContextToXmlFromNode(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
										/*[in]*/ CContextCallback* pContextCallback,
										/*[in]*/ IXMLDOMNode* piSourceNode,
										/*[in]*/ const CContextOptions& options);

static HRESULT SetContextToXmlFromParentNode(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
												/*[in]*/ CContextCallback* pContextCallback,
												/*[in]*/ IXMLDOMElement* piSourceElement,
												/*[in]*/ const CContextOptions& options);

static HRESULT SetContextToXmlFromProperties(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
												/*[in]*/ CContextCallback* pContextCallback,
												/*[in]*/ IILXProperties* piProps,
												/*[in]*/ const CContextOptions& options);

static HRESULT GetContextFromXmlUsingQueryDoc(	/*[in]*/ MSXML::IXMLDOMDocument* piContextDoc,
												/*[in]*/ MSXML::IXMLDOMDocument* piQueryDoc,
												/*[in]*/ const CContextOptions& options,
												/*[out]*/ VARIANT* pvarResult);

static HRESULT GetContextFromXmlUsingPropNames(	/*[in]*/ MSXML::IXMLDOMDocument* piContextDoc,
												/*[in]*/ BSTR bstrQueryPropNames,
												/*[in]*/ const CContextOptions& options,
												/*[out]*/ VARIANT* pvarResult);

static HRESULT GetContextFromXmlUsingPropName(	/*[in]*/ MSXML::IXMLDOMDocument* piContextDoc,
												/*[in]*/ BSTR bstrQueryPropName,
												/*[in]*/ const CContextOptions& options,
												/*[in,out]*/ MSXML::IXMLDOMDocument* piDestDoc,
												/*[in,out]*/ tstring* pstrOutputString,
												/*[in]*/ bool bIncludeNameInOutputString,
												/*[out]*/ VARIANT* pvarResult);

static HRESULT GetContextFromXmlUsingQueryString(	/*[in]*/ MSXML::IXMLDOMDocument* piContextDoc,
													/*[in]*/ BSTR bstrQueryString,
													/*[in]*/ const CContextOptions& options,
													/*[out]*/ VARIANT* pvarResult);

static HRESULT GetContextFromXmlUsingOptionsOnly(	/*[in]*/ IXMLDOMDocument* piContextDoc,
													/*[in]*/ const CContextOptions& options,
													/*[out,retval]*/ VARIANT* pvarResult);

static HRESULT ResolveContextProperties(	MSXML::IXMLDOMDocument* piXmlDoc,
											BSTR bstrQueryProps,
											BSTR bstrAttributeName,
											TCHAR cVariableDelimiter,
											bool bEraseUnknowns,
											bool bUrlEncodeValues,
											BSTR* pbstrResolvedProps);

static HRESULT Variant2String(	/*[in]*/ VARIANT* pvar, 
								/*[in]*/ bool bNoPersist,
								/*[out]*/ BSTR* pbstr);

static HRESULT LoadContext(	const TCHAR* szFilePath, 
							/*[in]*/ CContextCallback* pContextCallback,
							MSXML::IXMLDOMDocument* piXmlDoc);
	//
	// Clears the XML Context document and loads a new one from the file specified.
	//

static HRESULT SaveContext(const TCHAR* szFilePath, MSXML::IXMLDOMDocument* piXmlDoc);
	//
	// Same as calling piXmlDoc->save(szFilePath) but with error logging.
	//

// Constants
static const CComBSTR bstrPROPS_ELEMENT		= L"PROPS";
static const CComBSTR bstrATTRIBUTES_ATTR	= L"Attributes";

//////////////////////////////////////////////
// CONTEXT CALLBACK (DEFAULT) IMPLEMENTATION
//////////////////////////////////////////////

CContextCallback::CContextCallback()
	: m_spiXmlContextChanges()
{ }

CContextCallback::~CContextCallback()
{ }

HRESULT CContextCallback::StartTrackingContextChanges()
{
	HRESULT hr = S_OK;

	if (!m_spiXmlContextChanges)
	{
		hr = CreateContextDocument(&m_spiXmlContextChanges, true);
		VERIFY_HR_COND(hr, m_spiXmlContextChanges, 
			_T("Failed to create Context XML document."), ILXLOG_ERROR);
	}

	return S_OK;
}

HRESULT CContextCallback::ClearContextChanges()
{
	HRESULT hr = S_OK;

	if (m_spiXmlContextChanges)
	{
		hr = RemoveContextProperty(m_spiXmlContextChanges, bstrNAME_ATTR, 0, 0);
		VERIFY_HR(hr, _T("Failed to remove all context properties."), ILXLOG_ERROR);
		return S_OK;
	}
	else
	{
		return S_FALSE;
	}
}

HRESULT CContextCallback::AddContextChange(	/*[in]*/ MSXML::IXMLDOMElement* piPropElement,
											/*[in]*/ const CContextOptions& options)
{
	HRESULT hr = S_OK;

	if (m_spiXmlContextChanges)
	{
		hr = SetContextToXml(	m_spiXmlContextChanges, 
								0, 
								CComVariant(piPropElement), 
								options,
								CComVariant());
		VERIFY_HR0(hr, ILXLOG_ERROR, _T("Failed to set context property."));
	}

	return S_OK;
}

HRESULT CContextCallback::BeforeSetContext(	/*[in]*/ MSXML::IXMLDOMElement* piPropElement,
											/*[in]*/ const CContextOptions& options,
											/*[in]*/ BSTR bstrPropertyName,
											/*[in]*/ BSTR bstrAttributeName,
											/*[in]*/ VARIANT varOldValue,
											/*[in,out]*/ VARIANT varNewValue)
{
	HRESULT hr = S_OK;

	if (!bstrPropertyName) return E_POINTER;

	if (bstrAttributeName &&
		wcscmp(bstrPropertyName, bstrSYMBOL_PROP_NAME) == 0 &&
		wcscmp(bstrAttributeName, bstrVALUE_ATTR) == 0)
	{
		// Don't bother uppercasing unless its a simple string
		if (varNewValue.vt == VT_BSTR)
		{
			if (!varNewValue.bstrVal) return E_POINTER;
			wcsupr(varNewValue.bstrVal);
		}
		else if (varNewValue.vt == (VT_VARIANT|VT_BYREF))
		{
			_ASSERTE(varNewValue.pvarVal);
			if (!varNewValue.pvarVal) return E_POINTER;

			if (varNewValue.pvarVal->vt == VT_BSTR)
			{
				if (!varNewValue.pvarVal->bstrVal) return E_POINTER;
				wcsupr(varNewValue.pvarVal->bstrVal);
			}
		}
	}

	return S_OK;
}

HRESULT CContextCallback::AfterSetContext(	/*[in]*/ MSXML::IXMLDOMElement* piPropElement,
											/*[in]*/ const CContextOptions& options,
											/*[in]*/ BSTR bstrPropertyName,
											/*[in]*/ BSTR bstrAttributeName,
											/*[in]*/ VARIANT varOldValue,
											/*[in]*/ VARIANT varNewValue)
{
	return S_OK;
}

///////////////////////////////////
// CONTEXT OPTIONS IMPLEMENTATION
///////////////////////////////////

CContextOptions::CContextOptions()
	: eReason(CTXT_REASON_UNINITIALIZED)
	, eAction(CTXT_ACTION_UNINITIALIZED)
	, eFormat(CTXT_FORMAT_UNINITIALIZED)
	, bstrAttributeName(bstrVALUE_ATTR)
	, bEraseUnknowns(true)
	, bUpdateOnly(false)
	, bDelimiterIsSet(false)
	, cDelimiter(cDEFAULT_PROPERTY_DELIMITER)
{ }

CContextOptions::CContextOptions(VARIANT varOptions)
	: eReason(CTXT_REASON_UNINITIALIZED)
	, eAction(CTXT_ACTION_UNINITIALIZED)
	, eFormat(CTXT_FORMAT_UNINITIALIZED)
	, bstrAttributeName(bstrVALUE_ATTR)
	, bEraseUnknowns(true)
	, bUpdateOnly(false)
	, bDelimiterIsSet(false)
	, cDelimiter(cDEFAULT_PROPERTY_DELIMITER)
{ 
	init(varOptions);
}

CContextOptions::CContextOptions(const EContextReason& eReason)
	: eReason(eReason)
	, eAction(CTXT_ACTION_UNINITIALIZED)
	, eFormat(CTXT_FORMAT_UNINITIALIZED)
	, bstrAttributeName(bstrVALUE_ATTR)
	, bEraseUnknowns(true)
	, bUpdateOnly(false)
	, bDelimiterIsSet(false)
	, cDelimiter(cDEFAULT_PROPERTY_DELIMITER)
{ }

CContextOptions::CContextOptions(const EContextAction& eAction)
	: eReason(CTXT_REASON_UNINITIALIZED)
	, eAction(eAction)
	, eFormat(CTXT_FORMAT_UNINITIALIZED)
	, bstrAttributeName(bstrVALUE_ATTR)
	, bEraseUnknowns(true)
	, bUpdateOnly(false)
	, bDelimiterIsSet(false)
	, cDelimiter(cDEFAULT_PROPERTY_DELIMITER)
{ }

CContextOptions::CContextOptions(const CContextOptions& that)
	: eReason(that.eReason)
	, eAction(that.eAction)
	, eFormat(that.eFormat)
	, bstrAttributeName(that.bstrAttributeName)
	, bEraseUnknowns(that.bEraseUnknowns)
	, bUpdateOnly(that.bUpdateOnly)
	, bDelimiterIsSet(that.bDelimiterIsSet)
	, cDelimiter(that.cDelimiter)
{ }

CContextOptions& CContextOptions::operator=(const CContextOptions& that)
{
	if (this != &that)
	{
		eReason				= that.eReason;
		eAction				= that.eAction;
		eFormat				= that.eFormat;
		bstrAttributeName	= that.bstrAttributeName;
		bEraseUnknowns		= that.bEraseUnknowns;
		bUpdateOnly			= that.bUpdateOnly;
		bDelimiterIsSet		= that.bDelimiterIsSet;
		cDelimiter			= that.cDelimiter;
	}

	return *this;
}

CContextOptions::~CContextOptions()
{ }

HRESULT CContextOptions::init(VARIANT varOptions)
{
	// Reset defaults
	eReason				= CTXT_REASON_UNINITIALIZED;
	eAction				= CTXT_ACTION_UNINITIALIZED;
	eFormat				= CTXT_FORMAT_UNINITIALIZED;
	bstrAttributeName	= bstrVALUE_ATTR;
	bEraseUnknowns		= true;
	bUpdateOnly			= false;
	bDelimiterIsSet		= false;
	cDelimiter			= cDEFAULT_PROPERTY_DELIMITER;

	BSTR bstrOptions = 0;
	
	if (varOptions.vt == VT_BSTR)
	{
		bstrOptions = varOptions.bstrVal;
	}
	else if (varOptions.vt == VT_I4)
	{
		eReason = EContextReason(varOptions.lVal);
		return S_OK;
	}
	else if (varOptions.vt == (VT_VARIANT | VT_BYREF))
	{
		if (varOptions.pvarVal->vt == VT_BSTR)
		{
			bstrOptions = varOptions.pvarVal->bstrVal;
		}
		else if (varOptions.pvarVal->vt == VT_I4)
		{
			eReason = EContextReason(varOptions.pvarVal->lVal);
			return S_OK;
		}
	}
	else
	{
		return S_FALSE;
	}

	if (!bstrOptions)
	{
		return ILXLOG(E_POINTER, _T("Failed to parse VARIANT Options."), ILXLOG_ERROR);
	}

	bool bErrors = false;

	TypeListStrings listOptions;
	DelimitedString2StringList(bstrOptions, &listOptions, cOPTIONS_DELIMITER);

	for(TypeListStrings::const_iterator it = listOptions.begin();
		it != listOptions.end();
		++it)
	{
		const tstring& strNameValuePair = *it;

		if (strNameValuePair.empty())
		{
			ILXLOGMSG1(ILXLOG_WARNING,
				_T("Encountered an empty option for GetContext or SetContext - '%s'."), 
				bstrOptions);
			bErrors = true;
			continue;
		}

		// Process the options that are simply flags that are true if present
		// (e.g. "UpdateOnly")

		if (wcscmp(strNameValuePair.c_str(), szOPTION_NAME_ERASE_UNKNOWNS) == 0)
		{
			bEraseUnknowns = true;
			continue;
		}
		else if (wcscmp(strNameValuePair.c_str(), szOPTION_NAME_UPDATE_ONLY) == 0)
		{
			bUpdateOnly = true;
			continue;
		}

		tstring::size_type pos = strNameValuePair.find_first_of(_T('='));
		if (pos == tstring::npos)
		{
			ILXLOGMSG1(ILXLOG_WARNING, 
				_T("Couldn't find '=' (e.g. \"Reason=Discovery\") in '%s'."), 
				strNameValuePair.c_str());

			_ASSERTE(!"Couldn't find '='");
			bErrors = true;
			continue;
		}

		tstring strName = strNameValuePair.substr(0, pos);
		if (strName.empty())
		{
			ILXLOGMSG1(ILXLOG_WARNING, 
				_T("The option name is empty in option '%s'."),
				strNameValuePair.c_str());

			_ASSERTE(!"Name is empty");
			bErrors = true;
			continue;
		}

		tstring strValue = strNameValuePair.substr(pos+1, tstring::npos);

		// "Reason" option
		if (wcscmp(strName.c_str(), szOPTION_NAME_REASON) == 0)
		{
			if (eReason != CTXT_REASON_UNINITIALIZED)
			{
				ILXLOGMSG1(ILXLOG_WARNING, _T("Overwriting previous value for '%s' option."),
					strName.c_str());
			}

			if (strValue.empty())
			{
				eReason = CTXT_REASON_UNINITIALIZED;
			}
			else if (wcscmp(strValue.c_str(), szREASON_DRAG_AND_DROP) == 0)
			{
				eReason = CTXT_REASON_DRAG_AND_DROP;
			}
			else if (wcscmp(strValue.c_str(), szREASON_RMB) == 0)
			{
				eReason = CTXT_REASON_RMB;
			}
			else if (wcscmp(strValue.c_str(), szREASON_PROGRAMMATIC) == 0)
			{
				eReason = CTXT_REASON_PROGRAMMATIC;
			}
			else if (wcscmp(strValue.c_str(), szREASON_UI) == 0)
			{
				eReason = CTXT_REASON_UI;
			}
			else if (wcscmp(strValue.c_str(), szREASON_DISCOVERY) == 0)
			{
				eReason = CTXT_REASON_DISCOVERY;
			}
			else if (wcscmp(strValue.c_str(), szREASON_SHORTCUT) == 0)
			{
				eReason = CTXT_REASON_SHORTCUT;
			}
			else
			{
				ILXLOGMSG2(ILXLOG_WARNING, _T("Unrecognized option value '%s'='%s'."),
					strName.c_str(), strValue.c_str());
				bErrors = true;
				continue;
			}
		}

		// "Action" option
		else if (wcscmp(strName.c_str(), szOPTION_NAME_ACTION) == 0)
		{
			if (eAction != CTXT_ACTION_UNINITIALIZED)
			{
				ILXLOGMSG1(ILXLOG_WARNING, _T("Overwriting previous value for '%s' option."),
					strName.c_str());
			}

			if (strValue.empty())
			{
				eAction = CTXT_ACTION_UNINITIALIZED;
			}
			else if (wcscmp(strValue.c_str(), szACTION_QUERY) == 0)
			{
				eAction = CTXT_ACTION_QUERY;
			}
			else if (wcscmp(strValue.c_str(), szACTION_URL_QUERY) == 0)
			{
				eAction = CTXT_ACTION_URL_QUERY;
			}
			else if (wcscmp(strValue.c_str(), szACTION_REMOVE) == 0)
			{
				eAction = CTXT_ACTION_REMOVE;
			}
			else if (wcscmp(strValue.c_str(), szACTION_REMOVE_ATTRIBUTE) == 0)
			{
				eAction = CTXT_ACTION_REMOVE_ATTRIBUTE;
			}
			else if (wcscmp(strValue.c_str(), szACTION_LOAD) == 0)
			{
				eAction = CTXT_ACTION_LOAD;
			}
			else if (wcscmp(strValue.c_str(), szACTION_SAVE) == 0)
			{
				eAction = CTXT_ACTION_SAVE;
			}
			else if (wcscmp(strValue.c_str(), szACTION_REPLACE) == 0)
			{
				eAction = CTXT_ACTION_REPLACE;
			}
			else
			{
				ILXLOGMSG2(ILXLOG_WARNING, _T("Unrecognized option value '%s'='%s'."),
					strName.c_str(), strValue.c_str());
				bErrors = true;
				continue;
			}
		}
		
		// "Format" option
		else if (wcscmp(strName.c_str(), szOPTION_NAME_FORMAT) == 0)
		{
			if (eFormat != CTXT_FORMAT_UNINITIALIZED)
			{
				ILXLOGMSG1(ILXLOG_WARNING, _T("Overwriting previous value for '%s' option."),
					strName.c_str());
			}

			if (strValue.empty())
			{
				eFormat = CTXT_FORMAT_UNINITIALIZED;
			}
			else if (wcscmp(strValue.c_str(), szFORMAT_DOCUMENT) == 0)
			{
				eFormat = CTXT_FORMAT_DOCUMENT;
			}
			else if (wcscmp(strValue.c_str(), szFORMAT_NODE) == 0)
			{
				eFormat = CTXT_FORMAT_NODE;
			}
			else if (wcscmp(strValue.c_str(), szFORMAT_STRING) == 0)
			{
				eFormat = CTXT_FORMAT_STRING;
			}
			else if (wcscmp(strValue.c_str(), szFORMAT_VARIANT) == 0)
			{
				eFormat = CTXT_FORMAT_VARIANT;
			}
			else
			{
				ILXLOGMSG2(ILXLOG_WARNING, _T("Unrecognized option value '%s'='%s'."),
					strName.c_str(), strValue.c_str());
				bErrors = true;
				continue;
			}
		}

		// "Attribute" option
		else if (wcscmp(strName.c_str(), szOPTION_NAME_ATTRIBUTE) == 0)
		{
			if (!bstrAttributeName != 0)
			{
				ILXLOGMSG2(ILXLOG_WARNING, _T("Overwriting previous value for '%s' option ('%s')."),
					strName.c_str(),
					bstrAttributeName);
			}

			if (strValue.empty())
			{
				bstrAttributeName.Empty();
			}
			else
			{
				bstrAttributeName = strValue.c_str();
			}
		}

		// "Delimiter" option
		else if (wcscmp(strName.c_str(), szOPTION_NAME_DELIMITER) == 0)
		{
			if (cDelimiter != cDEFAULT_PROPERTY_DELIMITER)
			{
				ILXLOGMSG2(ILXLOG_WARNING, _T("Overwriting previous value for '%s' option ('%c')."),
					strName.c_str(),
					cDelimiter);
			}

			if (strValue.empty())
			{
				cDelimiter = cDEFAULT_PROPERTY_DELIMITER;
			}
			else if (strValue.size() == 1)
			{
				setDelimiter(strValue[0]);
			}
			else
			{
				ILXLOGMSG1(ILXLOG_WARNING, _T("Delimiter must be one character '%s'."),
					strValue.c_str());
				bErrors = true;
				continue;
			}
		}

		// "EraseUnknowns" option
		else if (wcscmp(strName.c_str(), szOPTION_NAME_ERASE_UNKNOWNS) == 0)
		{
			if (strValue.empty() ||
				strValue[0] == L'Y')
			{
				bEraseUnknowns = true;
			}
			else if (strValue[0] == L'N')
			{
				bEraseUnknowns = false;
			}
			else
			{
				ILXLOGMSG1(ILXLOG_WARNING, _T("EraseUnknowns must be 'Y' or 'N' not '%s'."),
					strValue.c_str());
				bErrors = true;
				continue;
			}
		}

		// "UpdateOnly" option
		else if (wcscmp(strName.c_str(), szOPTION_NAME_UPDATE_ONLY) == 0)
		{
			if (strValue.empty() ||
				strValue[0] == L'Y')
			{
				bUpdateOnly = true;
			}
			else if (strValue[0] == L'N')
			{
				bUpdateOnly = false;
			}
			else
			{
				ILXLOGMSG1(ILXLOG_WARNING, _T("UpdateOnly must be 'Y' or 'N' not '%s'."),
					strValue.c_str());
				bErrors = true;
				continue;
			}
		}

		else
		{
			ILXLOGMSG2(ILXLOG_WARNING, _T("Unrecognized option '%s'='%s'."),
				strName.c_str(), strValue.c_str());
			bErrors = true;
			continue;
		}
	}

	return !bErrors ? S_OK : S_FALSE;
}

void CContextOptions::setDelimiter(const TCHAR cDelimiterIn)
{ 
	cDelimiter = cDelimiterIn;
	bDelimiterIsSet = true;
}

const TCHAR CContextOptions::getDelimiter() const
{
	return cDelimiter;
}

bool CContextOptions::isDelimiterSet() const
{
	return bDelimiterIsSet;
}

////////////////////////////////////////////////////////////////
//                    HELPER FUNCTIONS
////////////////////////////////////////////////////////////////

//*********************************************************************
// FUNCTION		:	SetContextAttribute
//					
// DESCRIPTION	:	Sets an attribute value on a context property.
//					If the property doesn't exist then it is created.
//					
// PARAMETERS	:	
//   piXmlDoc			- The context document to modify.
//   bstrPropertyName	- Name of the context property to modify.
//   bstrAttributeName	- Name of the attribute to modify.	
//   varAttributeValue	- New value for the attribute.
//					
//*********************************************************************
HRESULT SetContextAttribute(	IXMLDOMDocument* piXmlDoc,
								CContextCallback* pContextCallback,
								const CContextOptions& options,
								BSTR bstrPropertyName,
								BSTR bstrAttributeName,
								VARIANT varAttributeValue)
{
	HRESULT hr = S_OK;

	_ASSERTE(piXmlDoc && bstrPropertyName && bstrAttributeName);
	if (!piXmlDoc || !bstrPropertyName || !bstrAttributeName) return E_POINTER;
	if (!*bstrPropertyName || !*bstrAttributeName) return E_INVALIDARG;

	CComVariant varOldAttributeValue;

	// Step 1:	First try to retrieve the context property

	CComPtr<IXMLDOMElement> spiPropElement;
	hr = FindContextProperty(piXmlDoc, bstrPropertyName, &spiPropElement);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to retrieve context property '%s'."), bstrPropertyName);

	// Step 2:	The context property was not found so create it

	if (hr == S_FALSE)
	{
		if (IsVariantEmptyOrUnspecified(&varAttributeValue))
		{
			// If the property doesn't exist and the attribute value is empty then
			// don't bother creating an empty <PROP>
			return S_FALSE;
		}

		hr = piXmlDoc->createElement(bstrPROP_ELEMENT, &spiPropElement);
		VERIFY_HR_COND(hr, hr == S_OK && spiPropElement,
			_T("Failed to create Context PROP element."), ILXLOG_ERROR);

		hr = spiPropElement->setAttribute(bstrNAME_ATTR, CComVariant(bstrPropertyName));
		VERIFY_HR_COND1(hr, hr == S_OK, ILXLOG_ERROR,
			_T("Failed to set the name attribute for property '%s'."), bstrPropertyName);

		CComPtr<IXMLDOMElement> spiContextElement;
		hr = piXmlDoc->get_documentElement(&spiContextElement);
		VERIFY_HR_COND(hr, hr == S_OK && spiContextElement, 
			_T("Failed to get the document element."), ILXLOG_ERROR);

		hr = AppendWhitespace(piXmlDoc, spiContextElement, _T("\t"));
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add XML whitespace."), ILXLOG_ERROR);
		}

		hr = spiContextElement->appendChild(spiPropElement, 0);
		VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to create Context PROP element."), 
			ILXLOG_ERROR);

		hr = AppendWhitespace(piXmlDoc, spiContextElement, _T("\n"));
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add XML comment."), ILXLOG_ERROR);
		}
	}
	else
	{
		// Step 3:	The context property was found so get its current value

		hr = spiPropElement->getAttribute(bstrAttributeName, &varOldAttributeValue);
		VERIFY_HR(hr, _T("Failed to get the old attribute value."), ILXLOG_ERROR);

		if (hr == S_FALSE) // Attribute Not Found
		{
			if (IsVariantEmpty(&varAttributeValue))
			{
				// The attribute is not found so we shouldn't try to remove it
				return S_FALSE;
			}
		}
		else if (hr == S_OK) // Attribute Found
		{
			// Don't bother updating the value (and firing events) if its the same
			hr = ::VarCmp(&varOldAttributeValue, &varAttributeValue, LOCALE_USER_DEFAULT, 0);
			if (hr == VARCMP_EQ)
			{
				return S_FALSE;
			}
		}
	}

	_ASSERTE(spiPropElement);

	// Step 4:	Now set the attribute value for this context property

	if (pContextCallback)
	{
		hr = pContextCallback->BeforeSetContext(	spiPropElement,
													options,
													bstrPropertyName, 
													bstrAttributeName,
													varOldAttributeValue,
													varAttributeValue);
		if (hr != S_OK) return hr;
	}

	if (IsVariantEmpty(&varAttributeValue))
	{
		// We remove empty properties as an optimization (reduces disk space)
		hr = spiPropElement->removeAttribute(bstrAttributeName);
		VERIFY_HR1(hr, ILXLOG_ERROR, 
			_T("Failed to set '%s' attribute."), bstrAttributeName);
	}
	else
	{
		hr = spiPropElement->setAttribute(bstrAttributeName, varAttributeValue);
		VERIFY_HR_COND1(hr, hr == S_OK, ILXLOG_ERROR, 
			_T("Failed to set '%s' attribute."), bstrAttributeName);
	}

	if (pContextCallback && !options.bUpdateOnly)
	{
		pContextCallback->AddContextChange(spiPropElement, options);

		pContextCallback->AfterSetContext(	spiPropElement,
											options,
											bstrPropertyName, 
											bstrAttributeName,
											varOldAttributeValue,
											varAttributeValue);
	}

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	SetContextToXmlFromPropNode
//					
// DESCRIPTION	:	Replace context or add or set a context property.
//					
// PARAMETERS	:	
//   piDestDoc			- The context document to modify.
//   piSourceElement	- A <PROP> element.  Must have the "Name"
//						attribute.
//					
//*********************************************************************
HRESULT SetContextProperty(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
							/*[in]*/ CContextCallback* pContextCallback,
							/*[in]*/ IXMLDOMElement* piSourceElement,
							/*[in]*/ const CContextOptions& options)
{
	HRESULT hr = S_OK;

	if (!piDestDoc || !piSourceElement) return E_POINTER;

	// Step 1:	Get the name of the new context property

	CComVariant varPropertyName;
	hr = piSourceElement->getAttribute(bstrNAME_ATTR, &varPropertyName);
	VERIFY_HR_COND(hr,	hr == S_OK && 
						varPropertyName.vt == VT_BSTR && 
						varPropertyName.bstrVal && 
						*varPropertyName.bstrVal,
		_T("Failed to retrieve NAME attribute from context node."), ILXLOG_ERROR);

	if (options.eAction == CTXT_ACTION_REMOVE)
	{
		return RemoveContextProperty(piDestDoc, bstrNAME_ATTR, varPropertyName.bstrVal, 0);
	}

	if (pContextCallback)
	{
		pContextCallback->BeforeSetContext(	piSourceElement,
											options,
											varPropertyName.bstrVal,
											0,
											CComVariant(),
											CComVariant());
	}

	// Step 2:	See if the context property already exists

	CComPtr<IXMLDOMElement> spiFoundPropElement;
	hr = FindContextProperty(piDestDoc, varPropertyName.bstrVal, &spiFoundPropElement);
	VERIFY_HR(hr, _T("FindContextProperty() failed."), ILXLOG_ERROR);

	CComPtr<IXMLDOMElement> spiDocumentElement;
	hr = piDestDoc->get_documentElement(&spiDocumentElement);
	VERIFY_HR_COND(hr, hr == S_OK && spiDocumentElement, 
		_T("Failed to get the document element."), ILXLOG_ERROR);

	if (spiFoundPropElement)
	{
		// Step 3:	Replace the old context property with the new one

		hr = spiDocumentElement->replaceChild(piSourceElement, spiFoundPropElement, 0);
		VERIFY_HR_COND1(hr, hr == S_OK, ILXLOG_ERROR,
			_T("Failed to replace child '%s'."), varPropertyName.bstrVal);
	}
	else
	{
		// Step 4:	Create the new context property

		CComPtr<IXMLDOMNode> spiSourceNodeCopy;
		hr = piSourceElement->cloneNode(VARIANT_TRUE, &spiSourceNodeCopy);
		VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to clone source context node."), ILXLOG_ERROR);

		hr = AppendWhitespace(piDestDoc, spiDocumentElement, _T("\t"));
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add XML whitespace."), ILXLOG_ERROR);
		}

		CComPtr<IXMLDOMNode> spiNewPropNode;
		hr = spiDocumentElement->appendChild(spiSourceNodeCopy, &spiNewPropNode);
		VERIFY_HR_COND0(hr, hr == S_OK, ILXLOG_ERROR, _T("Failed to append context node."));

		hr = AppendWhitespace(piDestDoc, spiDocumentElement, _T("\n"));
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add XML comment."), ILXLOG_ERROR);
		}
	}

	if (pContextCallback && !options.bUpdateOnly)
	{
		pContextCallback->AddContextChange(piSourceElement, options);

		pContextCallback->AfterSetContext(	piSourceElement,
											options,
											varPropertyName.bstrVal,
											0,
											CComVariant(),
											CComVariant());
	}

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	CreateContextDocument
//					
// DESCRIPTION	:	Creates an XML document object and optionally
//					creates the <CONTEXT> document element.
//					
// PARAMETERS	:	
//   ppiXmlDoc	
//   bInitialize	- If true, will create the <CONTEXT> document
//					element.
//					
//*********************************************************************
HRESULT CreateContextDocument(	IXMLDOMDocument** ppiXmlDoc, 
								bool bInitialize)
{
	if (!ppiXmlDoc) return E_POINTER;
	if (*ppiXmlDoc) return E_INVALIDARG;

	HRESULT hr = S_OK;

	hr = ::CoCreateInstance(	CLSID_DOMDocument,
								0,
								CLSCTX_ALL,
								IID_IXMLDOMDocument,
								reinterpret_cast<void**>(ppiXmlDoc));
	VERIFY_HR_COND(hr, *ppiXmlDoc, _T("Failed to create XML document."), ILXLOG_ERROR);

	// Set synchronous loading
	hr = (*ppiXmlDoc)->put_async(VARIANT_FALSE);
	VERIFY_HR(hr, _T("Failed to change async property."), ILXLOG_ERROR);

	// Make sure we keep the whitespace (slower but prettier)
	hr = (*ppiXmlDoc)->put_preserveWhiteSpace(VARIANT_TRUE);
	VERIFY_HR(hr, _T("Failed to change whitespace property."), ILXLOG_ERROR);

	// Don't resolve DTD or namespaces
	hr = (*ppiXmlDoc)->put_resolveExternals(VARIANT_FALSE);
	VERIFY_HR(hr, _T("Failed to change resolve externals property."), ILXLOG_ERROR);

	// Don't validate the XML against a schema or DTD
	hr = (*ppiXmlDoc)->put_validateOnParse(VARIANT_FALSE);
	VERIFY_HR(hr, _T("Failed to change validateonparse property."), ILXLOG_ERROR);

	if (bInitialize)
		return InitializeContextDocument(*ppiXmlDoc);
	else
		return S_OK;
}

//*********************************************************************
// FUNCTION		:	InitializeContextDocument
//					
// DESCRIPTION	:	Creates the top-level <CONTEXT> element.
//					
// PARAMETERS	:	
//   piXmlDoc	- The context document to modify.
//					
//*********************************************************************
HRESULT InitializeContextDocument(IXMLDOMDocument* piXmlDoc)
{
	if (!piXmlDoc) return E_POINTER;

	HRESULT hr = S_OK;

	hr = AppendILXComment2(piXmlDoc, 0, false);
	if (FAILED(hr))
	{
		ILXLOG(hr, _T("Failed to add XML comment."), ILXLOG_ERROR);
	}

	CComPtr<IXMLDOMElement> spiContextElement;
	hr = piXmlDoc->createElement(bstrCONTEXT_ELEMENT, &spiContextElement);
	VERIFY_HR_COND(hr, hr == S_OK && spiContextElement,
		_T("Failed to create top-level CONTEXT element."), ILXLOG_ERROR);

	hr = piXmlDoc->appendChild(spiContextElement, 0);
	VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to create top-level CONTEXT element."), 
		ILXLOG_ERROR);

	hr = AppendWhitespace(piXmlDoc, spiContextElement, _T("\n"));
	if (FAILED(hr))
	{
		ILXLOG(hr, _T("Failed to add XML comment."), ILXLOG_ERROR);
	}

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	GetContextAttribute
//					
// DESCRIPTION	:	Retrieves the attribute value for a context property
//					as a variant.
// RETURNS		:	
//   HRESULT 		S_FALSE - If the context property or attribute was
//					not found.
// PARAMETERS	:	
//   piXmlDoc			- The context document to search.
//   bstrPropertyName	- The name of the context property (e.g. "Symbol")
//   bstrAttributeName	- The name of the attribute (e.g. "Value")
//   pvarAttributeValue	- [out] The variant value of the attribute.
//					
//*********************************************************************
HRESULT GetContextAttribute(	IXMLDOMDocument* piXmlDoc,
								BSTR bstrPropertyName,
								BSTR bstrAttributeName,
								VARIANT* pvarAttributeValue)
{
	// Verify arguments
	if (!piXmlDoc || !bstrPropertyName || !pvarAttributeValue) return E_POINTER;
	if (!*bstrPropertyName) return E_INVALIDARG;
	if (pvarAttributeValue->vt != VT_EMPTY) return E_INVALIDARG;

	// Initialize out params
	pvarAttributeValue->vt = VT_EMPTY;

	HRESULT hr = S_OK;

	CComPtr<IXMLDOMElement> spiPropElement;
	hr = FindContextProperty(piXmlDoc, bstrPropertyName, &spiPropElement);
	if (hr == S_FALSE) 
		return S_FALSE;

	VERIFY_HR_COND1(hr, spiPropElement, ILXLOG_ERROR, _T("Failed to retrieve property '%s'."),
		bstrPropertyName);

	hr = spiPropElement->getAttribute(bstrAttributeName, pvarAttributeValue);
	if (hr == S_FALSE) return S_FALSE;
	
	VERIFY_HR1(hr, ILXLOG_WARNING, 
		_T("Failed to retrieve value for '%s' XML context property."),
		bstrPropertyName);

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	FindContextProperty
//					
// DESCRIPTION	:	Retrieves the context property from the context
//					document.
//					
// RETURNS		:	
//   HRESULT 		S_FALSE - The context property was not found.
//					
// PARAMETERS	:	
//   piXmlDoc			 - The context document to search.
//   bstrPropertyName	 - The context property to search for.
//   ppiFoundPropElement - [out] The returned <PROP> element.
//					
//*********************************************************************
HRESULT FindContextProperty(	IXMLDOMDocument* piXmlDoc,
								BSTR bstrPropertyName,
								IXMLDOMElement** ppiFoundPropElement)
{
	// Verify arguments
	if (!piXmlDoc || !bstrPropertyName || !ppiFoundPropElement) return E_POINTER;
	if (!*bstrPropertyName) return E_INVALIDARG;
	if (*ppiFoundPropElement) return E_INVALIDARG;

	// Initialize out params
	*ppiFoundPropElement = 0;

	HRESULT hr = S_OK;

	TCHAR szPropName[1000];

	hr = CreateXslQueryString(	bstrNAME_ATTR,
								bstrPropertyName, 
								szPropName, 
								(sizeof szPropName / sizeof *szPropName) - 1);
	VERIFY_HR(hr, _T("Failed to create query string."), ILXLOG_ERROR);

	CComPtr<IXMLDOMNode> spiPropNode;
	hr = piXmlDoc->selectSingleNode(CComBSTR(szPropName), &spiPropNode);
	if (hr == S_FALSE) 
		return S_FALSE;

	VERIFY_HR_COND1(hr, hr == S_OK && spiPropNode, ILXLOG_WARNING,
		_T("Failed to locate property '%s'.  OnGetContext must not have set it."),
		bstrPropertyName);

	hr = spiPropNode->QueryInterface(	IID_IXMLDOMElement, 
										reinterpret_cast<void**>(ppiFoundPropElement));
	VERIFY_HR_COND(hr, *ppiFoundPropElement, _T("Failed to QI for IXMLDOMElement."), 
		ILXLOG_ERROR);

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	RemoveContextProperty
//					
// DESCRIPTION	:	Removes a context property from the context document.
//					
// RETURNS		:	
//   HRESULT 		S_FALSE - If the context property was not found.
//					
// PARAMETERS	:	
//   piXmlDoc			- The context document.
//   bstrAttributeName	- 
//   bstrAttributeValue	- 
//					
//*********************************************************************
HRESULT RemoveContextProperty(	IXMLDOMDocument* piXmlDoc,
								BSTR bstrAttributeName,
								BSTR bstrAttributeValue,
								BSTR bstrAttributeNameToRemove)
{
	HRESULT hr = S_OK;

	// Verify arguments
	if (!piXmlDoc || !bstrAttributeName) return E_POINTER;
	if (!*bstrAttributeName) return E_INVALIDARG;
	if (bstrAttributeNameToRemove && !*bstrAttributeNameToRemove) return E_INVALIDARG;

	if (bstrAttributeNameToRemove && wcscmp(bstrAttributeNameToRemove, bstrNAME_ATTR) == 0)
	{
		_ASSERTE(false);
		return ILXLOG(E_INVALIDARG, _T("Not allowed to remove the Name attribute."),
			ILXLOG_ERROR);
	}

	TCHAR szXslQueryString[1000];

	hr = CreateXslQueryString(	bstrAttributeName,
								bstrAttributeValue, 
								szXslQueryString, 
								(sizeof szXslQueryString / sizeof *szXslQueryString) - 1);
	VERIFY_HR(hr, _T("Failed to create query string."), ILXLOG_ERROR);

	CComPtr<IXMLDOMNodeList> spiNodeList;
	hr = piXmlDoc->selectNodes(CComBSTR(szXslQueryString), &spiNodeList);
	VERIFY_HR_COND1(hr, hr == S_OK && spiNodeList, ILXLOG_ERROR,
		_T("selectNodes(%s) failed."), szXslQueryString);

	CComPtr<IXMLDOMElement> spiDocumentElement;
	hr = piXmlDoc->get_documentElement(&spiDocumentElement);
	VERIFY_HR_COND(hr, hr == S_OK && spiDocumentElement, 
		_T("Failed to get the document element."), ILXLOG_ERROR);

	CComPtr<IXMLDOMNode> spiNode;
	hr = spiNodeList->nextNode(&spiNode);
	VERIFY_HR(hr, _T("Failed to get the next node."), ILXLOG_ERROR);

	while (spiNode)
	{
		if (bstrAttributeNameToRemove)
		{
			CComQIPtr<IXMLDOMElement> spiElement(spiNode);
			VERIFY_COND(spiElement, _T("Failed to QI for IXMLDOMElement."), ILXLOG_ERROR);

			hr = spiElement->removeAttribute(bstrAttributeNameToRemove);
			VERIFY_HR_COND1(hr, hr == S_OK, ILXLOG_ERROR, _T("Failed to remove attribute '%s'."),
				bstrAttributeName);
		}
		else
		{
			CComPtr<IXMLDOMNode> spiTabNode;
			CComPtr<IXMLDOMNode> spiNewlineNode;
			hr = spiNode->get_previousSibling(&spiTabNode);
		
			if (hr != S_OK || !spiTabNode)
			{
				hr = FAILED(hr) ? hr : E_FAIL;
				ILXLOG(hr, _T("Failed to remove whitespace (tab)."), ILXLOG_WARNING);
			}
			else
			{
				DOMNodeType typeNode = NODE_INVALID;
				hr = spiTabNode->get_nodeType(&typeNode);
				VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to retrieve node type."), ILXLOG_ERROR);

				if (typeNode != NODE_TEXT)
				{
					spiTabNode = 0;
				}
				else
				{
					// Ignore S_FALSE because the first property won't have a previous
					// sibling
					hr = spiTabNode->get_previousSibling(&spiNewlineNode);
					if (hr != S_FALSE && (FAILED(hr) || !spiNewlineNode))
					{
						hr = FAILED(hr) ? hr : E_FAIL;
						ILXLOG(hr, _T("Failed to remove whitespace (newline)."), ILXLOG_WARNING);
					}
					else if (spiNewlineNode)
					{
						typeNode = NODE_INVALID;
						hr = spiNewlineNode->get_nodeType(&typeNode);
						VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to retrieve node type."), ILXLOG_ERROR);

						if (typeNode != NODE_TEXT)
						{
							spiNewlineNode = 0;
						}
					}
				}
			}

			hr = spiDocumentElement->removeChild(spiNode, 0);
			VERIFY_HR(hr, _T("Failed to remove child."), ILXLOG_ERROR);

			if (spiTabNode)
			{
				hr = spiDocumentElement->removeChild(spiTabNode, 0);
				VERIFY_HR(hr, _T("Failed to remove child."), ILXLOG_ERROR);

				if (spiNewlineNode)
				{
					hr = spiDocumentElement->removeChild(spiNewlineNode, 0);
					VERIFY_HR(hr, _T("Failed to remove child."), ILXLOG_ERROR);
				}
			}
		}
		// Get the next item
		spiNode = 0;
		hr = spiNodeList->nextNode(&spiNode);
		VERIFY_HR(hr, _T("Failed to get the next node."), ILXLOG_ERROR);

	} // while each node

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	ResolveContextProperties
//					
// DESCRIPTION	:	Finds and replaces context property names in the
//					query string with the property values.  Property
//					names are designated by enclosing them with a
//					delimiter (e.g. "%Symbol%").
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piXmlDoc			- The context document used to resolve properties.
//   bstrQueryProps		- The query string (e.g. "The symbol is %Symbol%.")
//   bstrAttributeName	- The attribute to use for the value (e.g. "Value").
//   cVariableDelimiter	- The property name delimiter (e.g. '%')
//   bEraseUnknowns		- If true, unknown property names are
//						  removed (e.g. "The symbol is .").
//   pbstrResolvedProps	- [ouy] The resolved string (e.g. "The symbol is IBM.").
//					
// COMMENTS		:	cVariableDelimiter should be '$' for parameters inside a
//					URL. According to RFC 1738, '$' can be safely used in a URL.
//					Other characters were rejected for the following reasons:
//					'#' - designates a URL anchor
//					'%' - designates the start of a URL encoded character
//					'@' - could be confused for an email address
//					'|' - Can start a unix command pipe
//					'!' - Can start a unix command
//*********************************************************************
HRESULT ResolveContextProperties(	IXMLDOMDocument* piXmlDoc,
									BSTR bstrQueryProps,
									BSTR bstrAttributeName,
									TCHAR cVariableDelimiter,
									bool bEraseUnknowns,
									bool bUrlEncodeValues,
									BSTR* pbstrResolvedProps)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	// Verify arguments
	_ASSERTE(bstrQueryProps);
	_ASSERTE(pbstrResolvedProps);
	_ASSERTE(piXmlDoc);
	_ASSERTE(bstrAttributeName);
	if (!piXmlDoc || !bstrQueryProps || !bstrAttributeName || !pbstrResolvedProps) 
		return E_POINTER;

	if (!*bstrAttributeName) return E_INVALIDARG;

	// Quick check for trivial case
	if (!*bstrQueryProps)
	{
		*pbstrResolvedProps = ::SysAllocString(L"");
		return S_OK;
	}

	tstring strNewValue = bstrQueryProps;
	tstring::size_type nStart = 0;
	bool bValueHasChanged = false;

	while (nStart < strNewValue.length())
	{
		// Step 1:	Find the first '%'

		tstring::size_type nFind1 = strNewValue.find(cVariableDelimiter, nStart);

		if (nFind1 == tstring::npos)
			break; // No variables left to substitute

		++nFind1; // Skip over '%'

		// Eg: "joe%"
		if (nFind1 >= strNewValue.length())
			break; // No variables left to substitute

		// Skip "%%" and "% hello%"
		if (strNewValue[nFind1] == cVariableDelimiter || strNewValue[nFind1] == L' ')
		{
			if (bEraseUnknowns)
			{
				// Convert it ("%%" -> "%")
				strNewValue.erase(nFind1 - 1, 1);
				bValueHasChanged = true;
				nStart = nFind1;
			}
			else
			{
				// Leave it alone ("%%" -> "%%")
				nStart = nFind1 + 1;
			}

			continue;
		}

		// Step 2:	Find the second '%'

		tstring::size_type nFind2 = strNewValue.find(cVariableDelimiter, nFind1);

		if (nFind2 == tstring::npos)
			break; // No variables left to substitute

		--nFind2; // Character before the second '%'

		// Sanity check (never happens)
		if (nFind2 >= strNewValue.length() ||	
			nFind2 <= 0 ||
			nFind1 > nFind2)
		{
			_ASSERTE(false);
			nStart = nFind1;
			continue;
		}

		// Ignore variables that end with a space (e.g. "%joe %")
		else if (strNewValue[nFind2] == L' ')
		{
			nStart = nFind1;
			continue;
		}

		// Step 3:	Extract the context name (e.g. "Symbol")

		tstring strContextName = strNewValue.substr(nFind1, nFind2-nFind1+1);

		_ASSERTE(strContextName.length() > 0);

		// Step 4:	Get the context value (e.g. "IBM")

		CComVariant varContextValue;
		hr = GetContextAttribute(	piXmlDoc,
									CComBSTR(strContextName.c_str()),
									bstrAttributeName,
									&varContextValue);
		if (FAILED(hr))
		{
			ILXLOG1(hr, ILXLOG_WARNING, _T("Failed to get context property '%s'."), 
				strContextName.c_str());
			// Remember first error code
			hrRet = FAILED(hrRet) ? hrRet : hr;
		}

		CComBSTR bstrContextValue;
		hr = Variant2String(&varContextValue, false, &bstrContextValue);
		if (FAILED(hr))
		{
			ILXLOG4(hr, ILXLOG_WARNING, 
				_T("Failed to convert context property to a string (<%s %s=%s %s=\?>)."), 
				bstrPROP_ELEMENT,
				bstrNAME_ATTR,
				strContextName.c_str(),
				bstrAttributeName);
		}

		// Step 5:	Replace the variable ("%Symbol%") with the value ("IBM")

		if (hr == S_OK || bEraseUnknowns)
		{
			wchar_t* pszValueToUse = 0;

			const unsigned long nStaticBufferLen = 1000;

			wchar_t* szCanonicalValueAllocatedBuffer = 0;
			wchar_t szCanonicalValueStaticBuffer[nStaticBufferLen + 1];

			if (!bUrlEncodeValues || !bstrContextValue || !*bstrContextValue)
			{
				pszValueToUse = bstrContextValue;
			}
			else
			{
				// Symbol will become part of url, so we must Canonicalize i.e.
				// convert unsafe characters and spaces into escape sequences.

				unsigned long nCanonicalValueBufferLen = nStaticBufferLen;
				
				BOOL bRet = InternetCanonicalizeUrl(	bstrContextValue, 
														szCanonicalValueStaticBuffer, 
														&nCanonicalValueBufferLen,
														0);
				if (bRet)
				{
					pszValueToUse = szCanonicalValueStaticBuffer;
				}
				else
				{
					long nLastError = ::GetLastError();
					if (nLastError == ERROR_INSUFFICIENT_BUFFER)
					{
						szCanonicalValueAllocatedBuffer = 
							new wchar_t[nCanonicalValueBufferLen + 1];

						bRet = InternetCanonicalizeUrl(	bstrContextValue, 
														szCanonicalValueAllocatedBuffer, 
														&nCanonicalValueBufferLen,
														0);
						if (!bRet)
						{
							nLastError = ::GetLastError();
							_ASSERTE(nLastError != ERROR_INSUFFICIENT_BUFFER);
						}
						else
						{
							pszValueToUse = szCanonicalValueAllocatedBuffer;
							nLastError = 0;
						}
					}

					if (nLastError)
					{
						return ILXLOG1(HRESULT_FROM_WIN32(nLastError), ILXLOG_ERROR,
							_T("Failed to canonicalize the property '%s'."), bstrContextValue);
					}
				}
			}

			strNewValue.replace(nFind1 - 1, 
								nFind2 - nFind1 + 3, 
								pszValueToUse ? pszValueToUse : L"");
			bValueHasChanged = true;

			delete[] szCanonicalValueAllocatedBuffer;

			// Step 6:	Keep replacing variables from where we left off
			nStart = nFind1 - 1 + bstrContextValue.Length();
		}
		else
		{
			// Step 6:	Keep replacing variables from where we left off
			nStart = nFind2 + 2;
		}
	}

	// Step 7:	Update the script group name

	if (bValueHasChanged)
	{
		if (*pbstrResolvedProps)
		{
			::SysFreeString(*pbstrResolvedProps);
		}

		*pbstrResolvedProps = ::SysAllocString(strNewValue.c_str());
	}
	else
	{
		*pbstrResolvedProps = ::SysAllocString(bstrQueryProps);
	}

	return hrRet;
}

//*********************************************************************
// FUNCTION		:	GetContextFromXml
//					
// DESCRIPTION	:	All-purpose function for retrieving context properties
//					from a context XML document.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piContextDoc	- The context XML document to query.
//   varContext		- Can be a string or IXMLDOMDocument that describes
//					which context properties were interested in.
//   options		- Some options that control what context is retrieved
//					or how it should be retrieved.
//   pvarResult		- [out] Can be a string or IXMLDOMDocument that will
//					contain the context results.
//					
// COMMENTS		:	See the Context Management Software Design Document
//					for more info.
//					
//*********************************************************************
HRESULT GetContextFromXml(	/*[in]*/ IXMLDOMDocument* piContextDoc,
							/*[in,optional]*/ VARIANT varContext,
							/*[in]*/ const CContextOptions& options,
							/*[out,retval]*/ VARIANT* pvarResult)
{
	HRESULT hr = S_OK;

	// Verify arguments
	if (!piContextDoc) return E_POINTER;
	if (pvarResult && pvarResult->vt != VT_EMPTY) return E_INVALIDARG;

	// Initialize out parameters
	if (pvarResult)
	{
		pvarResult->vt = VT_EMPTY;
	}

//	CComBSTR bstr;
//	piContextDoc->get_xml(&bstr);
//	ILXLOGMSG1(ILXLOG_INFO, _T("XML BEFORE GET: %s"), bstr);

	// Step 1:	Unwrap the Context object

	CComPtr<IXMLDOMDocument> spiTempContextDoc;
	CComPtr<IUnknown> spiUnkContext;
	BSTR bstrContext = 0;

	hr = GetContextObjectFromVariant(&varContext, &spiUnkContext, &bstrContext, &spiTempContextDoc);
	if (FAILED(hr)) return hr;

	// Handle a context query string or list of context property names
	if (bstrContext)
	{
		if (options.eAction == CTXT_ACTION_SAVE)
		{
			return SaveContext(bstrContext, piContextDoc);
		}
		else if (	options.eAction == CTXT_ACTION_QUERY ||
					options.eAction == CTXT_ACTION_URL_QUERY)
		{
			CContextOptions options2(options);

			if (!options2.isDelimiterSet())
			{
				options2.setDelimiter(cDEFAULT_QUERY_PROPERTY_DELIMITER);
			}

			return GetContextFromXmlUsingQueryString(piContextDoc, bstrContext, options2, pvarResult);
		}
		else
		{
			return GetContextFromXmlUsingPropNames(piContextDoc, bstrContext, options, pvarResult);
		}
	}

	// Handle copying the entire context document
	else if (!spiUnkContext)
	{
		return GetContextFromXmlUsingOptionsOnly(piContextDoc, options, pvarResult);
	}

	// Handle a query context document
	else
	{
		CComPtr<IXMLDOMDocument> spiXmlQueryDoc;
		hr = spiUnkContext->QueryInterface(__uuidof(spiXmlQueryDoc), (void**) &spiXmlQueryDoc);
		VERIFY_HR_COND(hr, spiXmlQueryDoc, _T("Failed to QI for IXMLDOMDocument."), ILXLOG_ERROR);

		return GetContextFromXmlUsingQueryDoc(piContextDoc, spiXmlQueryDoc, options, pvarResult);
	}
}

//*********************************************************************
// FUNCTION		:	GetContextFromXmlUsingQueryDoc
//					
// DESCRIPTION	:	Retrieves the context properties contained in the
//					query document from the context document.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piContextDoc	- The context document to search.
//   piQueryDoc		- The context document that contains the context
//					properties we are searching for.
//   options		- Some options.
//   pvarResult		- [out] Can be a string or IXMLDOMDocument that will
//					contain the context results.
//					
// COMMENTS		:	
//					
//*********************************************************************
HRESULT GetContextFromXmlUsingQueryDoc(	/*[in]*/ IXMLDOMDocument* piContextDoc,
										/*[in]*/ IXMLDOMDocument* piQueryDoc,
										/*[in]*/ const CContextOptions& options,
										/*[out,retval]*/ VARIANT* pvarResult)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	// Verify arguments
	if (!piContextDoc || !piQueryDoc) return E_POINTER;
	if (pvarResult && pvarResult->vt != VT_EMPTY) return E_INVALIDARG;

	// Initialize out params
	if (pvarResult)
	{
		pvarResult->vt = VT_EMPTY;
	}

	// Local variables
	CComPtr<IXMLDOMDocument> spiOutputDoc;
	tstring strOutputString;

	// Step 1:	Figure out the format for the returned variant

	EContextFormat eOutputFormat = options.eFormat;

	if (eOutputFormat == CTXT_FORMAT_UNINITIALIZED)
	{
		eOutputFormat = CTXT_FORMAT_DOCUMENT;
	}
	else if (eOutputFormat == CTXT_FORMAT_VARIANT)
	{
		return ILXLOG(E_INVALIDARG, 
			_T("Cannot specify Format=variant when multiple properties are returned."), 
			ILXLOG_WARNING);
	}

	// If the returned variant is VT_DISPATCH then create the XML document

	if (eOutputFormat == CTXT_FORMAT_DOCUMENT)
	{
		hr = CreateContextDocument(&spiOutputDoc, true);
		VERIFY_HR(hr, _T("Failed to create XML DOM document object."), ILXLOG_ERROR);
	}

	// Step 2:	Iterate over all the children

	CComPtr<IXMLDOMElement> spiDocumentElement;
	hr = piQueryDoc->get_documentElement(&spiDocumentElement);
	VERIFY_HR_COND(hr, hr == S_OK && spiDocumentElement, _T("Failed to get the document element."), 
		ILXLOG_ERROR);

	CComBSTR bstrTagName;
	hr = spiDocumentElement->get_tagName(&bstrTagName);
	VERIFY_HR_COND(hr, hr == S_OK && bstrTagName, _T("Failed to get the XML tag name."), ILXLOG_ERROR);

	if (wcscmp(bstrTagName, bstrCONTEXT_ELEMENT) != 0)
	{
		return S_FALSE;
	}

	CComPtr<IXMLDOMNodeList> spiNodeList;
	hr = spiDocumentElement->get_childNodes(&spiNodeList);
	VERIFY_HR_COND(hr, hr == S_OK && spiNodeList, _T("Failed to get child nodes."),
		ILXLOG_ERROR);

	CComPtr<IXMLDOMNode> spiSrcPropNode;
	hr = spiNodeList->nextNode(&spiSrcPropNode);
	VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);

	while (spiSrcPropNode)
	{
		// Step 3:	Skip non-ELEMENT query nodes (e.g., comments or whitespace)

		DOMNodeType typeNode = NODE_INVALID;
		hr = spiSrcPropNode->get_nodeType(&typeNode);
		VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to retrieve node type."), ILXLOG_ERROR);

		if (typeNode != NODE_ELEMENT)
		{
			// Get next node
			spiSrcPropNode = 0;
			hr = spiNodeList->nextNode(&spiSrcPropNode);
			VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
			continue;
		}

		// Step 4:	Ignore non-<PROP> nodes (e.g., custom XML nodes)

		CComQIPtr<IXMLDOMElement> spiQueryElement(spiSrcPropNode);
		VERIFY_COND(spiQueryElement, _T("Failed to QI for IXMLDOMElement."), ILXLOG_ERROR);

		CComBSTR bstrQueryTagName;
		hr = spiQueryElement->get_tagName(&bstrQueryTagName);
		VERIFY_HR_COND(hr, hr == S_OK && bstrQueryTagName, _T("Failed to retrieve element tag name."), ILXLOG_ERROR);

		if (wcscmp(bstrQueryTagName, bstrPROP_ELEMENT) != 0)
		{
			// Get next node
			spiSrcPropNode = 0;
			hr = spiNodeList->nextNode(&spiSrcPropNode);
			VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
			continue;
		}

		// Step 5:	Get the context property name to find
		
		CComVariant varQueryPropName;
		hr = spiQueryElement->getAttribute(bstrNAME_ATTR, &varQueryPropName);
		VERIFY_HR(hr, _T("Failed to retrieve context property name."), ILXLOG_ERROR);

		if (hr != S_OK ||
			varQueryPropName.vt != VT_BSTR ||
			!varQueryPropName.bstrVal ||
			!*varQueryPropName.bstrVal)
		{
			return S_FALSE;
		}

		if (eOutputFormat == CTXT_FORMAT_DOCUMENT)
		{
			hr = GetContextFromXmlUsingPropName(	piContextDoc, 
													varQueryPropName.bstrVal, 
													options, 
													spiOutputDoc, 
													0,
													true,
													0);
		}
		else
		{
			hr = GetContextFromXmlUsingPropName(	piContextDoc, 
													varQueryPropName.bstrVal, 
													options, 
													0, 
													&strOutputString,
													true,
													0);
		}

		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to retrieve context."), ILXLOG_ERROR);
			_ASSERTE(false);

			hrRet = FAILED(hrRet) ? hrRet : hr;
		}

		// Get next node
		spiSrcPropNode = 0;
		hr = spiNodeList->nextNode(&spiSrcPropNode);
		VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
	}

	if (eOutputFormat == CTXT_FORMAT_DOCUMENT && pvarResult)
	{
		pvarResult->vt = VT_DISPATCH;
		pvarResult->pdispVal = spiOutputDoc.Detach();
	}

	return hrRet;
}

//*********************************************************************
// FUNCTION		:	GetContextFromXmlUsingOptionsOnly
//					
// DESCRIPTION	:	Retrieves all context properties unless they are
//					filtered out by the options specified.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piContextDoc	- The context document to query/retrieve.
//   options		- Some filtering options.
//   pvarResult		- [out] Can be a string or IXMLDOMDocument depending
//					on options.eFormat.
//					
//*********************************************************************
HRESULT GetContextFromXmlUsingOptionsOnly(	/*[in]*/ IXMLDOMDocument* piContextDoc,
											/*[in]*/ const CContextOptions& options,
											/*[out,retval]*/ VARIANT* pvarResult)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	// Verify arguments
	if (!piContextDoc || !pvarResult) return E_POINTER;
	if (pvarResult->vt != VT_EMPTY) return E_INVALIDARG;

	// Initialize out params
	pvarResult->vt = VT_EMPTY;

	// Local variables
	CComPtr<IXMLDOMDocument> spiOutputDoc;
	tstring strOutputString;
	bool bIncludeNameInOutputString = true;

	// Step 1:	Figure out the format for the returned variant

	EContextFormat eOutputFormat = options.eFormat;

	if (eOutputFormat == CTXT_FORMAT_UNINITIALIZED)
	{
		eOutputFormat = CTXT_FORMAT_DOCUMENT;
	}
	else if (eOutputFormat == CTXT_FORMAT_VARIANT)
	{
		return ILXLOG(E_INVALIDARG, 
			_T("Cannot specify Format=variant when multiple properties are returned."), 
			ILXLOG_WARNING);
	}

	// If the returned variant is VT_DISPATCH then create the XML document

	if (eOutputFormat == CTXT_FORMAT_DOCUMENT)
	{
		hr = CreateContextDocument(&spiOutputDoc, false);
		VERIFY_HR(hr, _T("Failed to create XML DOM document object."), ILXLOG_ERROR);

		hr = piContextDoc->save(CComVariant(spiOutputDoc));

		// KLUDGE: For some reason save() sometimes returns INET_E_OBJECT_NOT_FOUND
		// when saving to an XML document.  Nothing in the documentation explains
		// why this happens.  It appears that it can be safely ignored.
		if (SUCCEEDED(hr) || 
			hr == INET_E_RESOURCE_NOT_FOUND || 
			hr == INET_E_OBJECT_NOT_FOUND)
		{
			pvarResult->vt = VT_DISPATCH;
			pvarResult->pdispVal = spiOutputDoc.Detach();
		}
		else
		{
			VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to copy context XML document."), ILXLOG_ERROR);
		}

		return S_OK;
	}

	_ASSERTE(eOutputFormat == CTXT_FORMAT_STRING);
	if (eOutputFormat != CTXT_FORMAT_STRING)
	{
		return ILXLOG1(E_INVALIDARG, ILXLOG_WARNING,
			_T("Unrecognized Format used (vt=%d) for Context Option."), eOutputFormat);
	}

	// Step 2:	Iterate over all the children

	CComPtr<IXMLDOMElement> spiDocumentElement;
	hr = piContextDoc->get_documentElement(&spiDocumentElement);
	VERIFY_HR_COND(hr, hr == S_OK && spiDocumentElement, _T("Failed to get the document element."), 
		ILXLOG_ERROR);

	CComBSTR bstrTagName;
	hr = spiDocumentElement->get_tagName(&bstrTagName);
	VERIFY_HR_COND(hr, hr == S_OK && bstrTagName, _T("Failed to get the XML tag name."), ILXLOG_ERROR);

	if (wcscmp(bstrTagName, bstrCONTEXT_ELEMENT) != 0)
	{
		return S_FALSE;
	}

	CComPtr<IXMLDOMNodeList> spiNodeList;
	hr = spiDocumentElement->get_childNodes(&spiNodeList);
	VERIFY_HR_COND(hr, hr == S_OK && spiNodeList, _T("Failed to get child nodes."),
		ILXLOG_ERROR);

	CComPtr<IXMLDOMNode> spiSrcPropNode;
	hr = spiNodeList->nextNode(&spiSrcPropNode);
	VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);

	while (spiSrcPropNode)
	{
		// Step 3:	Skip non-ELEMENT query nodes (e.g., comments or whitespace)

		DOMNodeType typeNode = NODE_INVALID;
		hr = spiSrcPropNode->get_nodeType(&typeNode);
		VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to retrieve node type."), ILXLOG_ERROR);

		if (typeNode != NODE_ELEMENT)
		{
			// Get next node
			spiSrcPropNode = 0;
			hr = spiNodeList->nextNode(&spiSrcPropNode);
			VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
			continue;
		}

		// Step 4:	Ignore non-<PROP> nodes (e.g., custom XML nodes)

		CComQIPtr<IXMLDOMElement> spiSrcPropElement(spiSrcPropNode);
		VERIFY_COND(spiSrcPropElement, _T("Failed to QI for IXMLDOMElement."), ILXLOG_ERROR);

		CComBSTR bstrPropTagName;
		hr = spiSrcPropElement->get_tagName(&bstrPropTagName);
		VERIFY_HR_COND(hr, hr == S_OK && bstrPropTagName, _T("Failed to retrieve element tag name."), ILXLOG_ERROR);

		if (wcscmp(bstrPropTagName, bstrPROP_ELEMENT) != 0)
		{
			// Get next node
			spiSrcPropNode = 0;
			hr = spiNodeList->nextNode(&spiSrcPropNode);
			VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
			continue;
		}

		// Step 5:	Retrieve the requested attribute

		CComVariant varPropAttrValue;
		hr = spiSrcPropElement->getAttribute(options.bstrAttributeName, &varPropAttrValue);
		VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to get attribute '%s'."), 
			options.bstrAttributeName);

		// Step 6:	Add the context property name and attribute value to the
		//			output string
		
		// Optimization: Convert it to BSTR inside GetContextXmlProperty()
		CComBSTR bstrValue;
		hr = Variant2String(&varPropAttrValue, false, &bstrValue);
		VERIFY_HR4(hr, ILXLOG_WARNING, 
				_T("Failed to convert context property to a string (<%s %s=%s %s=\?>)."), 
				bstrPROP_ELEMENT,
				bstrNAME_ATTR,
				bstrPropTagName,
				options.bstrAttributeName);

		// Optimization: Use a large static buffer
		if (!strOutputString.empty())
		{
			strOutputString.append(1, options.getDelimiter());
			_ASSERTE(bIncludeNameInOutputString);
		}
		
		if (bIncludeNameInOutputString)
		{
			strOutputString.append(bstrPropTagName);
			strOutputString.append(_T("="));
		}

		strOutputString.append(bstrValue);

		// Get next node
		spiSrcPropNode = 0;
		hr = spiNodeList->nextNode(&spiSrcPropNode);
		VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
	}

	return hrRet;
}

//*********************************************************************
// FUNCTION		:	GetContextFromXmlUsingQueryString
//					
// DESCRIPTION	:	Resolves a context query string.
//					
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piContextDoc	- The context document to query.
//   bstrQueryString - The context query string.
//   options		- Can specify the delimiter used in the query string
//					for surrounding the context property names.  Can
//					also specify whether to erase unknown properties and
//					which attribute to use.
//   pvarResult		- [out] The resulting string.
//					
//*********************************************************************
HRESULT GetContextFromXmlUsingQueryString(	/*[in]*/ IXMLDOMDocument* piContextDoc,
											/*[in]*/ BSTR bstrQueryString,
											/*[in,optional]*/ const CContextOptions& options,
											/*[out,retval]*/ VARIANT* pvarResult)
{
	HRESULT hr = S_OK;

	// Verify arguments
	if (!piContextDoc || !bstrQueryString || !pvarResult) return E_POINTER;
	if (pvarResult->vt != VT_EMPTY) return E_INVALIDARG;
	if (options.eAction != CTXT_ACTION_QUERY && options.eAction != CTXT_ACTION_URL_QUERY) return E_UNEXPECTED;

	// Initialize out parameters
	pvarResult->vt = VT_EMPTY;

	// Step 1:	Figure out the format for the returned variant

	EContextFormat eOutputFormat = options.eFormat;

	if (eOutputFormat == CTXT_FORMAT_UNINITIALIZED)
	{
		// We've been told to use the default format which is a string value
		eOutputFormat = CTXT_FORMAT_STRING;
	}
	else if (	eOutputFormat == CTXT_FORMAT_VARIANT || 
				eOutputFormat == CTXT_FORMAT_DOCUMENT)
	{
		return ILXLOG(E_INVALIDARG, 
			_T("Must specify Format=string when specifying a query string."), 
			ILXLOG_WARNING);
	}

	CComBSTR bstrResult;
	hr = ResolveContextProperties(	piContextDoc,
									bstrQueryString,
									options.bstrAttributeName,
									options.getDelimiter(),
									options.bEraseUnknowns,
									options.eAction == CTXT_ACTION_URL_QUERY,
									&bstrResult);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to resolve the context query string '%s'."), 
		bstrQueryString);

	pvarResult->vt = VT_BSTR;
	pvarResult->bstrVal = bstrResult.Detach();

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	GetContextFromXmlUsingPropNames
//					
// DESCRIPTION	:	Retrieves the specified context properties.
//					
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piContextDoc	- The context document to query.
//   bstrQueryPropNames	- The comma-delimited list of property names.
//   options		- Can change the list delimiter.
//   pvarResult		- [out] The resulting string or IXMLDOMDocument.
//					
// COMMENTS		:	Calls GetContextFromXmlUsingPropName() for each child.
//
//*********************************************************************
HRESULT GetContextFromXmlUsingPropNames(	/*[in]*/ IXMLDOMDocument* piContextDoc,
											/*[in]*/ BSTR bstrQueryPropNames,
											/*[in,optional]*/ const CContextOptions& options,
											/*[out,retval]*/ VARIANT* pvarResult)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	// Verify arguments
	if (!piContextDoc || !bstrQueryPropNames) return E_POINTER;
	if (pvarResult && pvarResult->vt != VT_EMPTY) return E_INVALIDARG;
	if (!pvarResult && options.eFormat != CTXT_FORMAT_UNINITIALIZED) 
		return E_INVALIDARG;

	// Initialize out parameters
	if (pvarResult)
	{
		pvarResult->vt = VT_EMPTY;
	}

	// Local variables
	CComPtr<IXMLDOMDocument> spiOutputDoc;
	tstring strOutputString;

	// Step 1:	Parse the list of context property names

	TypeListStrings listQueryPropertyNames;
	DelimitedString2StringList(bstrQueryPropNames, &listQueryPropertyNames, 
		options.getDelimiter());

	long nQueryPropNameCount = listQueryPropertyNames.size();

	_ASSERTE(nQueryPropNameCount > 0);

	// Step 2:	Figure out the format for the returned variant

	EContextFormat eOutputFormat = options.eFormat;

	if (eOutputFormat == CTXT_FORMAT_UNINITIALIZED)
	{
		// We've been told to use the default format which is a string value
		// if we are only asking for one property name and an XML document
		// otherwise.
		if (nQueryPropNameCount == 1)
			eOutputFormat = CTXT_FORMAT_STRING;
		else
			eOutputFormat = CTXT_FORMAT_DOCUMENT;
	}
	else if (	eOutputFormat == CTXT_FORMAT_VARIANT && 
				nQueryPropNameCount > 1)
	{
		return ILXLOG(E_INVALIDARG, 
			_T("Cannot specify Format=variant when multiple properties are returned."), 
			ILXLOG_WARNING);
	}

	// If the returned variant is VT_DISPATCH then create the XML document

	if (eOutputFormat == CTXT_FORMAT_DOCUMENT)
	{
		hr = CreateContextDocument(&spiOutputDoc, true);
		VERIFY_HR(hr, _T("Failed to create XML DOM document object."), ILXLOG_ERROR);
	}

	// Step 3:	Iterate through list of context names

	for(TypeListStrings::const_iterator it = listQueryPropertyNames.begin();
		it != listQueryPropertyNames.end();
		++it)
	{
		const tstring& strQueryPropName = *it;

		CComBSTR bstrQueryPropName = strQueryPropName.c_str();

		if (eOutputFormat == CTXT_FORMAT_DOCUMENT)
		{
			hr = GetContextFromXmlUsingPropName(	piContextDoc,
													bstrQueryPropName,
													options,
													spiOutputDoc,
													0,
													nQueryPropNameCount > 1,
													0);
		}
		else if (eOutputFormat == CTXT_FORMAT_STRING)
		{
			hr = GetContextFromXmlUsingPropName(	piContextDoc,
													bstrQueryPropName,
													options,
													0,
													&strOutputString,
													nQueryPropNameCount > 1,
													0);
		}
		else if (eOutputFormat == CTXT_FORMAT_VARIANT)
		{
			hr = GetContextFromXmlUsingPropName(	piContextDoc,
													bstrQueryPropName,
													options,
													0,
													0,
													nQueryPropNameCount > 1,
													pvarResult);
		}

		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to retrieve context."), ILXLOG_ERROR);
			_ASSERTE(false);

			hrRet = FAILED(hrRet) ? hrRet : hr;
		}
	}

	if (pvarResult)
	{
		if (eOutputFormat == CTXT_FORMAT_DOCUMENT)
		{
			pvarResult->vt = VT_DISPATCH;
			pvarResult->pdispVal = spiOutputDoc.Detach();
		}
		else if (eOutputFormat == CTXT_FORMAT_STRING)
		{
			pvarResult->vt = VT_BSTR;

			if (!strOutputString.empty())
			{
				pvarResult->bstrVal = ::SysAllocString(strOutputString.c_str());
			}
			else
			{
				pvarResult->bstrVal = ::SysAllocString(L"");
			}
		}
	}

	return hrRet;
}

//*********************************************************************
// FUNCTION		:	GetContextFromXmlUsingPropName
//					
// DESCRIPTION	:	Retrieves a context property and either adds it to
//					a context document, an output string, or a variant.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piContextDoc		- The context document to query.
//   bstrQueryPropName	- The context property names.
//   options			- Some options.
//   piDestDoc			- [in,out] The context document to add the
//						property to.  Can be NULL.
//   pstrOutputString	- [in,out] The string to add the property string
//						value to.  Can be NULL.
//   bIncludeNameInOutputString	- If true, the property name and value
//						are added to the output string.
//   pvarResult			- [out] The variant value of the property.  Can
//						be NULL.  Should only be specified if one property
//						is being retrieved.
//					
// COMMENTS		:	piDestDoc, pstrOutput, or pvarResult must be specified.
//					
//*********************************************************************
HRESULT GetContextFromXmlUsingPropName(	/*[in]*/ IXMLDOMDocument* piContextDoc,
										/*[in]*/ BSTR bstrQueryPropName,
										/*[in]*/ const CContextOptions& options,
										/*[in,out]*/ IXMLDOMDocument* piDestDoc,
										/*[in,out]*/ tstring* pstrOutputString,
										/*[in]*/ bool bIncludeNameInOutputString,
										/*[out]*/ VARIANT* pvarResult)
{
	// Verify arguments

	if (!bstrQueryPropName || !piContextDoc) return E_POINTER;
	if (!*bstrQueryPropName) return E_INVALIDARG;

	HRESULT hr = S_OK;

	// Here is where we could make sure that the source property value is empty - ME

	// Step 1:	See if the context property exists

	CComPtr<IXMLDOMElement> spiFoundPropElement;
	hr = FindContextProperty(piContextDoc, bstrQueryPropName, &spiFoundPropElement);
	VERIFY_HR(hr, _T("FindContextProperty() failed."), ILXLOG_ERROR);
	if (hr == S_FALSE)
	{
		// Context property doesn't exist
		return S_FALSE;
	}

	if (piDestDoc)
	{
		// Step 2:	Add the found context property to the result set

		// Alternative: Copy the query node instead of the data node and only
		// replace the attribute

		CComPtr<IXMLDOMNode> spiFoundPropNodeCopy;
		hr = spiFoundPropElement->cloneNode(VARIANT_TRUE, &spiFoundPropNodeCopy);
		VERIFY_HR_COND(hr, hr == S_OK && spiFoundPropNodeCopy, 
			_T("Failed to clone the found node."), ILXLOG_ERROR);

		CComPtr<IXMLDOMElement> spiDocumentElement;
		hr = piDestDoc->get_documentElement(&spiDocumentElement);
		VERIFY_HR_COND(hr, hr == S_OK && spiDocumentElement, 
			_T("Failed to get the document element."), ILXLOG_ERROR);

		hr = AppendWhitespace(piDestDoc, spiDocumentElement, _T("\t"));
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add XML whitespace."), ILXLOG_ERROR);
		}

		hr = spiDocumentElement->appendChild(spiFoundPropNodeCopy, 0);
		VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to add the found node to the result set."),
			ILXLOG_ERROR);

		hr = AppendWhitespace(piDestDoc, spiDocumentElement, _T("\n"));
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add XML comment."), ILXLOG_ERROR);
		}

		return S_OK;
	}

	// Step 3:	Retrieve the requested attribute

	CComVariant varFoundPropAttrValue;
	hr = spiFoundPropElement->getAttribute(options.bstrAttributeName, &varFoundPropAttrValue);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to get attribute '%s'."), 
		options.bstrAttributeName);

	if (hr != S_OK)
	{
		// Requested attribute was not found
		return S_FALSE;
	}

	if (pvarResult)
	{
		hr = varFoundPropAttrValue.Detach(pvarResult);
		VERIFY_HR4(hr, ILXLOG_WARNING, 
				_T("Failed to detach context property value (<%s %s=%s %s=\?>)."), 
				bstrPROP_ELEMENT,
				bstrNAME_ATTR,
				bstrQueryPropName,
				options.bstrAttributeName);
	}
	else if (pstrOutputString)
	{
		// Step 4:	Add the context property name and attribute value to the
		//			output string
		
		// Optimization: Convert it to BSTR inside GetContextXmlProperty()
		CComBSTR bstrValue;
		hr = Variant2String(&varFoundPropAttrValue, false, &bstrValue);
		VERIFY_HR4(hr, ILXLOG_WARNING, 
				_T("Failed to convert context property to a string (<%s %s=%s %s=\?>)."), 
				bstrPROP_ELEMENT,
				bstrNAME_ATTR,
				bstrQueryPropName,
				options.bstrAttributeName);

		// Optimization: Use a large static buffer
		if (!pstrOutputString->empty())
		{
			pstrOutputString->append(1, options.getDelimiter());
			_ASSERTE(bIncludeNameInOutputString);
		}
		
		if (bIncludeNameInOutputString)
		{
			pstrOutputString->append(bstrQueryPropName);
			pstrOutputString->append(_T("="));
		}

		pstrOutputString->append(bstrValue);
	}
	else
	{
		// We don't want the value we just want to know if it exists
		return S_OK;
	}

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	SetContextToXml
//					
// DESCRIPTION	:	All-purpose function for setting context properties
//					and for manipulating the context object.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piDestDoc	- [in,out] Context document that will be modified in-place.
//   varContext	- Which context properties to set.
//   options	- Must specify a reason why the properties are being set.
//				Can also specify an action like "remove", "replace", etc.
//   varValue	- If varContext is a list of property names then varValue
//				can be used to specify the attribute values.
//					
//*********************************************************************
HRESULT SetContextToXml(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
							/*[in]*/ CContextCallback* pContextCallback,
							/*[in]*/ VARIANT varContext,
							/*[in]*/ const CContextOptions& options,
							/*[in,optional]*/ VARIANT varValue)
{
	HRESULT hr = S_OK;

	// Verify input parameters
	if (!piDestDoc) return E_POINTER;

	if (pContextCallback)
	{
		hr = pContextCallback->ClearContextChanges();
		_ASSERTE(SUCCEEDED(hr));
	}

//	CComBSTR bstr;
//	piDestDoc->get_xml(&bstr);
//	ILXLOGMSG1(ILXLOG_INFO, _T("XML BEFORE SET: %s"), bstr);

	_ASSERTE(options.eReason != CTXT_REASON_UNINITIALIZED);
	VERIFY_COND(options.eReason != CTXT_REASON_UNINITIALIZED,
		_T("Failed to set context.  Must specify a Reason Option."), 
		ILXLOG_ERROR);

	// Step 1:	Unwrap the Context object

	CComPtr<IXMLDOMDocument> spiTempContextDoc;
	CComPtr<IUnknown> spiUnkContext;
	BSTR bstrContext = 0;

	hr = GetContextObjectFromVariant(&varContext, &spiUnkContext, &bstrContext, &spiTempContextDoc);
	if (FAILED(hr)) return hr;

	// Handle a filename or a list of property names to set
	if (bstrContext)
	{
		if (options.eAction == CTXT_ACTION_LOAD)
		{
			hr = LoadContext(bstrContext, pContextCallback, piDestDoc);
		}
		else
		{
			hr = SetContextToXmlFromString(piDestDoc, pContextCallback, bstrContext, options, varValue);
		}
	}

	// Handle an IXMLDOMDocument or IXMLDOMNode to set
	else if (spiUnkContext)
	{
		_ASSERTE(IsVariantEmptyOrUnspecified(&varValue));

		CComPtr<IXMLDOMDocument> spiSourceDocument;
		hr = spiUnkContext->QueryInterface(__uuidof(spiSourceDocument), (void**) &spiSourceDocument);
		if (hr == S_OK && spiSourceDocument)
		{
			// I was getting access violations sometimes when passing an IXMLDOMDocument
			// object across apartment boundaries (requires it to be marshalled) and
			// then copying the object onto the event queue.  It appears that by copying
			// the document it fixes the problem.  This is very expensive since we have
			// to copy the DOM each time.

			CComPtr<IXMLDOMDocument> spiSourceDocumentCopy;
	
			hr = ::CreateContextDocument(&spiSourceDocumentCopy, false);
			VERIFY_HR(hr, _T("Failed to create context XML document."), ILXLOG_ERROR);

			hr = spiSourceDocument->save(CComVariant(spiSourceDocumentCopy));
			VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to copy XML."), ILXLOG_ERROR);

			hr = SetContextToXmlFromNode(piDestDoc, pContextCallback, spiSourceDocumentCopy, options);
		}
		else 
		{
			// Sometimes we are passed an IXMLDOMDocument2.  This will happen if an
			// IXMLDOMDocument is marshalled from one apartment to another. For example,
			// when OnContextChanged is fired by the control it gets marshalled to the
			// ActiveILX's main thread where it gets copied to the event queue.

			CComPtr<MSXML3::IXMLDOMDocument2> spiSourceDocument2;
			hr = spiUnkContext->QueryInterface(__uuidof(spiSourceDocument2), (void**) &spiSourceDocument2);
			if (hr == S_OK && spiSourceDocument2)
			{
				// Its not possible to QI for IXMLDOMDocument or IXMLDOMNode for some
				// reason so I just create a new document and save to it.

				CComPtr<IXMLDOMDocument> spiSourceDocumentCopy;

				hr = ::CreateContextDocument(&spiSourceDocumentCopy, false);
				VERIFY_HR(hr, _T("Failed to create context XML document."), ILXLOG_ERROR);

				hr = spiSourceDocument2->save(CComVariant(spiSourceDocumentCopy));
				VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to copy XML."), ILXLOG_ERROR);

				hr = SetContextToXmlFromNode(piDestDoc, pContextCallback, spiSourceDocumentCopy, options);
			}
			else
			{
				CComPtr<IXMLDOMNode> spiSourceNode;
				hr = spiUnkContext->QueryInterface(IID_IXMLDOMNode, (void**) &spiSourceNode);
				if (hr == S_OK && spiSourceNode)
				{
					hr = SetContextToXmlFromNode(piDestDoc, pContextCallback, spiSourceNode, options);
				}
				else
				{
					CComPtr<IILXProperties> spiProperties;
					hr = spiUnkContext->QueryInterface(IID_IILXProperties, (void**) &spiProperties);
					if (hr == S_OK && spiProperties)
					{
						hr = SetContextToXmlFromProperties(piDestDoc, pContextCallback, spiProperties, options);
					}
					else
					{
						ILXLOG(hr, _T("Failed to QI for IXMLDOMDocument or IXMLDOMNode."), ILXLOG_ERROR);
					}
				}
			}
		}
	}
	else if (options.eAction == CTXT_ACTION_REMOVE ||
			options.eAction == CTXT_ACTION_REMOVE_ATTRIBUTE)
	{
		if (options.bstrAttributeName)
		{
			CComVariant varValue2;
			
			hr = ::VariantChangeType(&varValue2, &varValue, VARIANT_ALPHABOOL, VT_BSTR);
			VERIFY_HR_COND0(hr, varValue2.bstrVal, ILXLOG_ERROR, 
				_T("Failed to convert variant to a string."));

			BSTR bstrAttributeToRemove = 0;

			if (options.eAction == CTXT_ACTION_REMOVE_ATTRIBUTE)
			{
				bstrAttributeToRemove = options.bstrAttributeName;
			}

			hr = RemoveContextProperty(	piDestDoc, 
										options.bstrAttributeName,
										varValue2.bstrVal,
										bstrAttributeToRemove);
		}
		else
		{
			if (options.eAction == CTXT_ACTION_REMOVE_ATTRIBUTE)
			{
				return ILXLOG(E_INVALIDARG, 
					_T("Must specify the 'Attribute' option when specifying the 'Action=removeattribute' option."),
					ILXLOG_ERROR);
			}

			hr = RemoveContextProperty(piDestDoc, bstrNAME_ATTR, 0, 0);
		}
	}

//	bstr.Empty();
//	piDestDoc->get_xml(&bstr);
//	ILXLOGMSG1(ILXLOG_INFO, _T("XML AFTER SET: %s"), bstr);

	return hr;
}

//*********************************************************************
// FUNCTION		:	SetContextToXmlFromString
//					
// DESCRIPTION	:	Sets the attribute value for one or more context
//					properties.
// PARAMETERS	:	
//   piDestDoc	- The context document to modify.
//   bstrContextPropertyNames - The comma-delimited list of property names
//				to set.
//   options	- Can specify the list delimiter and attribute name.
//   varValue	- The attribute value to set.
//					
//*********************************************************************
HRESULT SetContextToXmlFromString(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
									/*[in]*/ CContextCallback* pContextCallback,
									/*[in]*/ BSTR bstrContextPropertyNames,
									/*[in]*/ const CContextOptions& options,
									/*[in]*/ VARIANT varValue)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	// Verify arguments
	if (!piDestDoc) return E_POINTER;

	// Step 1:	Parse the list of context property names

	TypeListStrings listContextPropertyNames;
	DelimitedString2StringList(bstrContextPropertyNames, &listContextPropertyNames, 
		options.getDelimiter());

	// Step 2:	Iterate through list of context property names

	for(TypeListStrings::const_iterator it = listContextPropertyNames.begin();
		it != listContextPropertyNames.end();
		++it)
	{
		const tstring& strPropName = *it;

		if (options.eAction == CTXT_ACTION_REMOVE)
		{
			hr = RemoveContextProperty(	piDestDoc, 
										bstrNAME_ATTR, 
										CComBSTR(strPropName.c_str()), 
										0);
		}
		else
		{
			hr = SetContextAttribute(	piDestDoc,
										pContextCallback,
										options,
										CComBSTR(strPropName.c_str()), 
										options.bstrAttributeName,
										varValue);
		}

		if (hr != S_OK)
		{
			if (FAILED(hr))
			{
				ILXLOG4(hr, ILXLOG_WARNING, 
						_T("Failed to set or remove context property value (<%s %s=%s %s=\?>)."), 
						bstrPROP_ELEMENT,
						bstrNAME_ATTR,
						strPropName.c_str(),
						options.bstrAttributeName.m_str ? options.bstrAttributeName.m_str : L"");
			}

			hrRet = hrRet != S_OK ? hrRet : hr;
		}
	}

	return hrRet;
}

//*********************************************************************
// FUNCTION		:	SetContextToXmlFromNode
//					
// DESCRIPTION	:	Sets one or more context properties from a source
//					<CONTEXT>, <PROPS>, or <PROP> element.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piDestDoc		- The context document to modify.
//   piSourceNode	- MUST be a NODE_DOCUMENT (<CONTEXT> or <PROPS>) or
//					NODE_ELEMENT (<PROP>) node.
//   options		- Some options.
//	
// COMMENTS		:	Forwards to SetContextToXmlFromParentNode() for
//					<CONTEXT> and <PROPS>.
//*********************************************************************
HRESULT SetContextToXmlFromNode(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
									/*[in]*/ CContextCallback* pContextCallback,
									/*[in]*/ IXMLDOMNode* piSourceNode,
									/*[in]*/ const CContextOptions& options)
{
	HRESULT hr = S_OK;

	if (!piDestDoc || !piSourceNode) return E_POINTER;

	// Step 1:	Skip non-ELEMENT query nodes (e.g., comments or whitespace)

	DOMNodeType typeNode = NODE_INVALID;
	hr = piSourceNode->get_nodeType(&typeNode);
	VERIFY_HR_COND(hr, hr == S_OK, 
		_T("Failed to retrieve node type."), ILXLOG_ERROR);

	// Step 2:	Ignore non-<PROP> nodes (e.g., custom XML nodes)

	CComQIPtr<IXMLDOMElement> spiSourceElement;
	
	if (typeNode == NODE_DOCUMENT)
	{
		CComQIPtr<IXMLDOMDocument> spiSourceDoc(piSourceNode);
		VERIFY_COND(spiSourceDoc, _T("Failed to QI for IXMLDOMDocument."), ILXLOG_ERROR);

		hr = spiSourceDoc->get_documentElement(&spiSourceElement);
		VERIFY_HR_COND(hr, hr == S_OK && spiSourceElement, 
			_T("Failed to retrieve the document element."), ILXLOG_ERROR);
	}
	else if (typeNode == NODE_ELEMENT)
	{ 
		spiSourceElement = piSourceNode;
		VERIFY_COND(spiSourceElement, _T("Failed to QI for IXMLDOMElement."), ILXLOG_ERROR);
	}
	else
	{
		return ILXLOG1(E_INVALIDARG, ILXLOG_ERROR, _T("Unrecognized node type '%d'."), typeNode);
	}

	CComBSTR bstrTagName;
	hr = spiSourceElement->get_tagName(&bstrTagName);
	VERIFY_HR_COND(hr, hr == S_OK && bstrTagName, _T("Failed to retrieve element tag name."), ILXLOG_ERROR);

	if (wcscmp(bstrTagName, bstrCONTEXT_ELEMENT) == 0 ||
		wcscmp(bstrTagName, bstrPROPS_ELEMENT) == 0)
	{
		return SetContextToXmlFromParentNode(piDestDoc, pContextCallback, spiSourceElement, options);
	}
	else if (wcscmp(bstrTagName, bstrPROP_ELEMENT) == 0)
	{
		return SetContextProperty(piDestDoc, pContextCallback, spiSourceElement, options);
	}
	else
	{
		return ILXLOG1(E_INVALIDARG, ILXLOG_ERROR, _T("Unrecognized context XML element '%s'."),
			bstrTagName);
	}

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	SetContextToXmlFromParentNode
//					
// DESCRIPTION	:	Sets one or more context properties from a source
//					<CONTEXT> or <PROPS> element.  The child <PROP>
//					elements are used.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piDestDoc		- [in,out] The context document to set.
//   piSourceElement - A node with zero or more child <PROP> elements
//					that will be copied to piDestDoc.
//   options		- Can specify Action=replace to clear the 
//					context document before setting the context
//					properties.
// COMMENTS		:	
//					
//*********************************************************************
HRESULT SetContextToXmlFromParentNode(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
										/*[in]*/ CContextCallback* pContextCallback,
										/*[in]*/ IXMLDOMElement* piSourceElement,
										/*[in]*/ const CContextOptions& options)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	if (!piDestDoc || !piSourceElement) return E_POINTER;

	// Step 1:	First clear the context document if requested

	if (options.eAction == CTXT_ACTION_REPLACE)
	{
		hr = RemoveContextProperty(piDestDoc, bstrNAME_ATTR, 0, 0);
		VERIFY_HR(hr, _T("Failed to remove all context properties."), ILXLOG_ERROR);
	}

	// Step 2:	Iterate over the source context properties

	CComPtr<IXMLDOMNodeList> spiNodeList;
	hr = piSourceElement->get_childNodes(&spiNodeList);
	VERIFY_HR_COND(hr, hr == S_OK && spiNodeList, _T("Failed to get child nodes."), 
		ILXLOG_ERROR);

	CComPtr<IXMLDOMNode> spiSrcPropNode;
	hr = spiNodeList->nextNode(&spiSrcPropNode);
	VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);

	while (spiSrcPropNode)
	{
		// Step 3:	Skip non-ELEMENT query nodes (e.g., comments or whitespace)

		DOMNodeType typeNode = NODE_INVALID;
		hr = spiSrcPropNode->get_nodeType(&typeNode);
		VERIFY_HR_COND(hr, hr == S_OK, 
			_T("Failed to retrieve node type."), ILXLOG_ERROR);

		if (typeNode != NODE_ELEMENT)
		{
			// Get next node
			spiSrcPropNode = 0;
			hr = spiNodeList->nextNode(&spiSrcPropNode);
			VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
			continue;
		}

		// Step 4:	Ignore non-<PROP> nodes (e.g., custom XML nodes)

		CComQIPtr<IXMLDOMElement> spiSrcPropElement(spiSrcPropNode);
		VERIFY_COND(spiSrcPropElement, _T("Failed to QI for IXMLDOMElement."), ILXLOG_ERROR);

		CComBSTR bstrTagName;
		hr = spiSrcPropElement->get_tagName(&bstrTagName);
		VERIFY_HR_COND(hr, hr == S_OK && bstrTagName, _T("Failed to retrieve element tag name."), ILXLOG_ERROR);

		if (wcscmp(bstrTagName, bstrPROP_ELEMENT) == 0)
		{
			// Step 5:	Remove or set the property
			hr = SetContextProperty(piDestDoc, pContextCallback, spiSrcPropElement, options);

			if (hr != S_OK)
			{
				if (FAILED(hr))
				{
					ILXLOG(hr, _T("Failed to set context."), ILXLOG_ERROR);
					_ASSERTE(false);
				}

				hrRet = hrRet != S_OK ? hrRet : hr;
			}
		}

		// Get next node
		spiSrcPropNode = 0;
		hr = spiNodeList->nextNode(&spiSrcPropNode);
		VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
	}

	return hrRet;
}

//*********************************************************************
// FUNCTION		:	SetContextToXmlFromParentNode
//					
// DESCRIPTION	:	Sets one or more context properties from a source
//					<CONTEXT> or <PROPS> element.  The child <PROP>
//					elements are used.
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   piDestDoc		- [in,out] The context document to set.
//   piSourceElement - A node with zero or more child <PROP> elements
//					that will be copied to piDestDoc.
//   options		- Can specify Action=replace to clear the 
//					context document before setting the context
//					properties.
// COMMENTS		:	
//					
//*********************************************************************
HRESULT SetContextToXmlFromProperties(	/*[in,out]*/ IXMLDOMDocument* piDestDoc,
										/*[in]*/ CContextCallback* pContextCallback,
										/*[in]*/ IILXProperties* piProps,
										/*[in]*/ const CContextOptions& options)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	if (!piDestDoc || !piProps) return E_POINTER;

	// Step 1:	First clear the context document if requested

	if (options.eAction == CTXT_ACTION_REPLACE)
	{
		hr = RemoveContextProperty(piDestDoc, bstrNAME_ATTR, 0, 0);
		VERIFY_HR(hr, _T("Failed to remove all context properties."), ILXLOG_ERROR);
	}

	// Step 2:	Iterate over the source context properties

	long nPropCount = 0;
	hr = piProps->get_Count(&nPropCount);
	VERIFY_HR(hr, _T("Failed to get property count."), ILXLOG_ERROR);

	for(long nItem = 1; nItem <= nPropCount; ++nItem)
	{
		// Get the item at this index
		CComVariant	varPropDisp;
		hr = piProps->get_Item(nItem, &varPropDisp);
		if (FAILED(hr) || varPropDisp.vt != VT_DISPATCH || !varPropDisp.pdispVal)
		{
			hr = FAILED(hr) ? hr : E_FAIL;
			ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to get property #%d."), nItem);
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		//query for IILXProperty
		CComQIPtr<IILXProperty> spiProp( varPropDisp.pdispVal );
		if (!spiProp)
		{
			ILXLOGMSG1(ILXLOG_ERROR, _T("Failed to QI for IILXProperty for property #%d."), 
				nItem);
			hrRet = FAILED(hrRet) ? hrRet : E_UNEXPECTED;
			continue;
		}

		CComBSTR bstrPropName;
		hr = spiProp->get_Name(&bstrPropName);
		if (FAILED(hr) || !bstrPropName || !*bstrPropName)
		{
			hr = FAILED(hr) ? hr : E_FAIL;
			ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to get name for property #%d."), 
				nItem);
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		CComVariant varValue;
		hr = spiProp->get_Value(&varValue);
		if (FAILED(hr))
		{
			ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to get value for '%s' property."), 
				bstrPropName);
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		if (!IsVariantEmptyOrUnspecified(&varValue))
		{
			hr = SetContextAttribute(	piDestDoc, 
										pContextCallback, 
										options, 
										bstrPropName,
										bstrVALUE_ATTR,
										varValue);
			if (hr != S_OK)
			{
				hrRet = hrRet != S_OK ? hrRet : hr;

				if (FAILED(hr))
				{
					ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to set value for '%s' property."), 
						bstrPropName);
					continue;
				}
			}
		}

		CComBSTR bstrDisplay;
		hr = spiProp->get_Display(&bstrDisplay);
		if (FAILED(hr))
		{
			ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to get the display value for '%s' property."), 
				bstrPropName);
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		if (bstrDisplay && *bstrDisplay)
		{
			hr = SetContextAttribute(	piDestDoc, 
										pContextCallback, 
										options, 
										bstrPropName,
										bstrDISPLAY_ATTR,
										CComVariant(bstrDisplay));
			if (hr != S_OK)
			{
				hrRet = hrRet != S_OK ? hrRet : hr;

				if (FAILED(hr))
				{
					ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to set value for '%s' property."), 
						bstrPropName);
					continue;
				}
			}
		}

		CComVariant varAttributes;
		hr = spiProp->get_Attributes(&varAttributes);
		if (FAILED(hr))
		{
			ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to get the display value for '%s' property."), 
				bstrPropName);
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		if (!IsVariantEmptyOrUnspecified(&varAttributes))
		{
			hr = SetContextAttribute(	piDestDoc, 
										pContextCallback, 
										options, 
										bstrPropName,
										bstrATTRIBUTES_ATTR,
										varAttributes);
			if (hr != S_OK)
			{
				hrRet = hrRet != S_OK ? hrRet : hr;

				if (FAILED(hr))
				{
					ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to set value for '%s' property."), 
						bstrPropName);
					continue;
				}
			}
		}
	}

	return hrRet;
}

// HELPER FUNCTIONS

HRESULT Variant2String(	/*[in]*/ VARIANT* pvar, 
						/*[in]*/ bool bNoPersist,
						/*[out]*/ BSTR* pbstr)
{
	HRESULT hr = S_OK;

	if (!pbstr) return E_POINTER;
	if (*pbstr) return E_INVALIDARG; // Forget to free?

	// Initialize out params
	*pbstr = 0;

	USES_CONVERSION;

	CComVariant varValue;
	hr = ::VariantChangeType(&varValue, pvar, VARIANT_ALPHABOOL, VT_BSTR);
	if (FAILED(hr)) 
	{
		TCHAR szErrorCode[100];
		_stprintf(szErrorCode, _T("<ERROR:0x%08X>"), hr);

		*pbstr = ::SysAllocString(szErrorCode);
		return *pbstr ? S_FALSE : E_OUTOFMEMORY;
	}
	else if (varValue.vt == VT_BSTR && varValue.bstrVal)
	{
		if (!bNoPersist)
		{
			*pbstr = varValue.bstrVal;
			varValue.vt = VT_EMPTY; // Now caller owns the memory

			return *pbstr ? S_OK : E_OUTOFMEMORY;
		}
		else
		{
			tstring strReturn;

			size_t nLen = ::SysStringLen(varValue.bstrVal);
			if (nLen > 0)
			{
				strReturn.assign(nLen, _T('*'));
			}

			*pbstr = ::SysAllocString(strReturn.c_str());
			return *pbstr ? S_OK : E_OUTOFMEMORY;
		}
	}
	else
	{
		TCHAR szErrorCode[100];
		_stprintf(szErrorCode, _T("<ERROR:Unexpected VarType %d>"), varValue.vt);

		*pbstr = ::SysAllocString(szErrorCode);
		return *pbstr ? S_FALSE : E_OUTOFMEMORY;
	}
}

bool IsVariantEmpty(const VARIANT* pvar)
{
	_ASSERTE(pvar);
	return	pvar->vt == VT_EMPTY ||
			(pvar->vt == (VT_VARIANT | VT_BYREF) && IsVariantEmpty(pvar->pvarVal));
}
bool IsVariantUnspecified(const VARIANT* pvar)
{
	_ASSERTE(pvar);
	return	pvar->vt == VT_NULL || 
			pvar->vt == VT_ERROR ||
			(pvar->vt == (VT_VARIANT | VT_BYREF) && IsVariantUnspecified(pvar->pvarVal));
}

bool IsVariantEmptyOrUnspecified(const VARIANT* pvar)
{
	_ASSERTE(pvar);
	return	pvar->vt == VT_EMPTY || 
			pvar->vt == VT_NULL || 
			pvar->vt == VT_ERROR ||
			(pvar->vt == (VT_VARIANT | VT_BYREF) && IsVariantUnspecified(pvar->pvarVal));
}

HRESULT CreateXslQueryString(	BSTR bstrAttributeName,
								BSTR bstrAttributeValue,
								TCHAR* szXslQueryString, 
								long nMaxLen)
{
	long nRet = 0;

	if (bstrAttributeName && bstrAttributeValue)
	{
		nRet = _sntprintf(	szXslQueryString, 
							nMaxLen,
							_T("%s/%s[@%s = \"%s\"]"), 
							bstrCONTEXT_ELEMENT,
							bstrPROP_ELEMENT,
							bstrAttributeName,
							bstrAttributeValue);
	}
	else if (bstrAttributeName)
	{
		nRet = _sntprintf(	szXslQueryString, 
							nMaxLen,
							_T("%s/%s[@%s]"), 
							bstrCONTEXT_ELEMENT,
							bstrPROP_ELEMENT,
							bstrAttributeName);
	}
	else
	{
		return E_POINTER;
	}

	szXslQueryString[nMaxLen] = _T('\0');

	VERIFY_COND2(nRet != -1, ILXLOG_ERROR,
			_T("Property name and value are over %d characters: '%s'."), 
			nMaxLen, bstrAttributeName);

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	GetContextObjectFromVariant
//					
// DESCRIPTION	:	Extracts the IUnknown or BSTR from the variant.
//					
// RETURNS		:	
//   HRESULT 		
//					
// PARAMETERS	:	
//   pvarContext	
//   ppiUnkContext	
//   pbstrContext	
//   ppiXmlDoc	
//					
// COMMENTS		:	pbstrContext will point to the VT_BSTR inside
//					pvarContext instead of copying it.  This is an
//					optimization that only works if pvarContext doesn't
//					go out of scope before pbstrContext.  ppiUnkContext
//					and ppiXmlDoc are reference counted however.
//					
//*********************************************************************
HRESULT GetContextObjectFromVariant(	VARIANT* pvarContext, 
										IUnknown** ppiUnkContext, 
										BSTR* pbstrContext,
										IXMLDOMDocument** ppiXmlDoc)
{
	HRESULT hr = S_OK;

	// Verify arguments
	if (!pvarContext || !ppiUnkContext || !pbstrContext || !ppiXmlDoc) return E_POINTER;

	// Initialize out params
	*ppiUnkContext = 0;
	*pbstrContext = 0;
	*ppiXmlDoc = 0;

	if (pvarContext->vt == VT_UNKNOWN)
	{
		*ppiUnkContext = pvarContext->punkVal;
		if (!*ppiUnkContext) return E_POINTER;
		(*ppiUnkContext)->AddRef();
	}
	else if (pvarContext->vt == VT_DISPATCH)
	{
		*ppiUnkContext = pvarContext->pdispVal;
		if (!*ppiUnkContext) return E_POINTER;
		(*ppiUnkContext)->AddRef();
	}
	else if (pvarContext->vt == VT_BSTR)
	{
		*pbstrContext = pvarContext->bstrVal;
		if (!*pbstrContext) return E_POINTER;
	}
	else if (pvarContext->vt == (VT_VARIANT | VT_BYREF) )
	{
		if (!pvarContext->pvarVal) return E_POINTER;

		if (pvarContext->pvarVal->vt == VT_UNKNOWN)
		{
			*ppiUnkContext = pvarContext->pvarVal->punkVal;
			if (!*ppiUnkContext) return E_POINTER;
			(*ppiUnkContext)->AddRef();
		}
		else if (pvarContext->pvarVal->vt == VT_DISPATCH)
		{
			*ppiUnkContext = pvarContext->pvarVal->pdispVal;
			if (!*ppiUnkContext) return E_POINTER;
			(*ppiUnkContext)->AddRef();
		}
		else if (pvarContext->pvarVal->vt == VT_BSTR)
		{
			*pbstrContext = pvarContext->pvarVal->bstrVal;
			if (!*pbstrContext) return E_POINTER;
		}
		else if (!IsVariantEmptyOrUnspecified(pvarContext->pvarVal))
		{
			return E_INVALIDARG;
		}
	}
	else if (!IsVariantEmptyOrUnspecified(pvarContext))
	{
		return E_INVALIDARG;
	}

	// Special Case: If the context is a string that starts with an open angle
	// bracket then see if its XML (e.g. 
	// "<CONTEXT><PROP Name="Joe" Value="Schmoe"/></CONTEXT>")

	if (*pbstrContext && **pbstrContext == L'<')
	{
		hr = CreateContextDocument(ppiXmlDoc, false);
		VERIFY_HR_COND(hr, *ppiXmlDoc, _T("Failed to create temporary context document."), ILXLOG_ERROR);

		VARIANT_BOOL vbIsSuccessful = VARIANT_FALSE;

		hr = (*ppiXmlDoc)->loadXML(*pbstrContext, &vbIsSuccessful);
		VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to copy XML."), ILXLOG_ERROR);

		if (vbIsSuccessful == VARIANT_FALSE)
		{
			hr = LogXmlError(*ppiXmlDoc);
			ILXLOG1(hr, ILXLOG_WARNING, _T("Context string is not valid xml (snippet:'%.20s')."), 
				*pbstrContext);
		}
		else
		{
			*ppiUnkContext = *ppiXmlDoc;
			(*ppiUnkContext)->AddRef();
			*pbstrContext = 0;
		}
	}

	return S_OK;
}

HRESULT LoadContext(	const TCHAR* szFilePath, 
						/*[in]*/ CContextCallback* pContextCallback,
						MSXML::IXMLDOMDocument* piXmlDoc)
{
	HRESULT hr = S_OK;

	// Verify arguments
	_ASSERTE(szFilePath && *szFilePath && piXmlDoc);
	if (!(szFilePath && *szFilePath && piXmlDoc)) return E_POINTER;

	CComPtr<IXMLDOMDocument> spiXmlDocToLoad;
	hr = CreateContextDocument(&spiXmlDocToLoad, false);
	VERIFY_HR(hr, _T("Failed to create XML context document."), ILXLOG_ERROR);

	VARIANT_BOOL vbIsSuccessful = VARIANT_FALSE;

	hr = spiXmlDocToLoad->load(CComVariant(szFilePath), &vbIsSuccessful);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to load context from XML file '%s'."), szFilePath);

	if (vbIsSuccessful == VARIANT_FALSE)
	{
		return LogXmlError(spiXmlDocToLoad);
	}
	else
	{
		// The load succeeded so update the context

		CContextOptions options;
		options.eReason = CTXT_REASON_PROGRAMMATIC;

		hr = SetContextToXml(	piXmlDoc, 
								pContextCallback,
								CComVariant(spiXmlDocToLoad),
								options,
								CComVariant());
		VERIFY_HR(hr, _T("Failed to copy context document."), ILXLOG_ERROR);
	}

	return S_OK;
}

HRESULT SaveContext(const TCHAR* szFilePath, MSXML::IXMLDOMDocument* piXmlDoc)
{
	_ASSERTE(szFilePath && *szFilePath && piXmlDoc);
	if (!(szFilePath && *szFilePath && piXmlDoc)) return E_POINTER;

	HRESULT hr = S_OK;

	// Step 1:	Make a copy of the context

	CContextOptions options;
	options.eFormat = CTXT_FORMAT_DOCUMENT;

	CComVariant varXmlDocCopy;
	hr = GetContextFromXml(	piXmlDoc, 
							CComVariant(),	// All context
							options,		// Put in XML document
							&varXmlDocCopy);
	VERIFY_HR_COND(hr, varXmlDocCopy.vt == VT_DISPATCH && varXmlDocCopy.pdispVal, 
		_T("Failed to copy context document."), ILXLOG_ERROR);

	CComQIPtr<IXMLDOMDocument> spiXmlDocCopy(varXmlDocCopy.pdispVal);
	VERIFY_COND(spiXmlDocCopy, _T("Failed to QI for IXMLDOMDocument."), ILXLOG_ERROR);

	// Step 2:	Remove all NoPersist attributes

	hr = RemoveContextProperty(spiXmlDocCopy, bstrNO_PERSIST_ATTR, 0, 0);
	VERIFY_HR(hr, _T("Failed to remove NoPersist context properties."), ILXLOG_ERROR);

	// Step 3:	Save the XML document

	hr = spiXmlDocCopy->save(CComVariant(szFilePath));
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to save context to XML file '%s'."), szFilePath);

	return S_OK;
}

HRESULT HasContextProperties(IXMLDOMDocument* piXmlDoc)
{
	_ASSERTE(piXmlDoc);

	// Verify arguments
	if (!piXmlDoc) return E_POINTER;

	HRESULT hr = S_OK;

	CComPtr<IXMLDOMElement> spiDocumentElement;
	hr = piXmlDoc->get_documentElement(&spiDocumentElement);
	VERIFY_HR_COND(hr, hr == S_OK && spiDocumentElement, _T("Failed to get the document element."), 
		ILXLOG_ERROR);

	CComBSTR bstrTagName;
	hr = spiDocumentElement->get_tagName(&bstrTagName);
	VERIFY_HR_COND(hr, hr == S_OK && bstrTagName, _T("Failed to get the XML tag name."), ILXLOG_ERROR);

	if (wcscmp(bstrTagName, bstrCONTEXT_ELEMENT) != 0)
	{
		return S_FALSE;
	}

	// Step 2:	Iterate over all the children

	CComPtr<IXMLDOMNodeList> spiNodeList;
	hr = spiDocumentElement->get_childNodes(&spiNodeList);
	VERIFY_HR_COND(hr, hr == S_OK && spiNodeList, _T("Failed to get child nodes."),
		ILXLOG_ERROR);

	CComPtr<IXMLDOMNode> spiSrcPropNode;
	hr = spiNodeList->nextNode(&spiSrcPropNode);
	VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);

	while (spiSrcPropNode)
	{
		// Step 3:	Skip non-ELEMENT query nodes (e.g., comments or whitespace)

		DOMNodeType typeNode = NODE_INVALID;
		hr = spiSrcPropNode->get_nodeType(&typeNode);
		VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to retrieve node type."), ILXLOG_ERROR);

		if (typeNode != NODE_ELEMENT)
		{
			// Get next node
			spiSrcPropNode = 0;
			hr = spiNodeList->nextNode(&spiSrcPropNode);
			VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
			continue;
		}

		// Step 4:	Ignore non-<PROP> nodes (e.g., custom XML nodes)

		CComQIPtr<IXMLDOMElement> spiQueryElement(spiSrcPropNode);
		VERIFY_COND(spiQueryElement, _T("Failed to QI for IXMLDOMElement."), ILXLOG_ERROR);

		CComBSTR bstrQueryTagName;
		hr = spiQueryElement->get_tagName(&bstrQueryTagName);
		VERIFY_HR_COND(hr, hr == S_OK && bstrQueryTagName, _T("Failed to retrieve element tag name."), ILXLOG_ERROR);

		if (wcscmp(bstrQueryTagName, bstrPROP_ELEMENT) != 0)
		{
			// Get next node
			spiSrcPropNode = 0;
			hr = spiNodeList->nextNode(&spiSrcPropNode);
			VERIFY_HR(hr, _T("Failed to get the next node in the attribute map."), ILXLOG_ERROR);
			continue;
		}

		return S_OK;
	}

	return S_FALSE;
}

const wchar_t* GetReasonString(const CContextOptions& options)
{
	switch (options.eReason)
	{
	case CTXT_REASON_UNINITIALIZED: return L"uninitialized";		break;
	case CTXT_REASON_DRAG_AND_DROP: return szREASON_DRAG_AND_DROP;	break;
	case CTXT_REASON_RMB:			return szREASON_RMB;			break;
	case CTXT_REASON_PROGRAMMATIC:	return szREASON_PROGRAMMATIC;	break;
	case CTXT_REASON_UI:			return szREASON_UI;				break;
	case CTXT_REASON_DISCOVERY:		return szREASON_DISCOVERY;		break;
	case CTXT_REASON_SHORTCUT:		return szREASON_SHORTCUT;		break;
	default:						return L"UNKNOWN";				break;
	}
}