//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/BreakpointCallback.cs 5     5/24/06 2:05p Eaddy $
//
// Description:
//
// See:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/BreakpointCallback.cs $
 * 
 * 5     5/24/06 2:05p Eaddy
 * o When setting a breakpoint for after advice, we
 * need to set it on the line after the jp's line
 * 
 * 4     5/05/06 6:18p Eaddy
 * o Did some renaming to improve clarity
 * o Can now list current advice and enable/disable (although
 * enable/disable doesn't actually work yet)
 * 
 * 3     4/21/06 12:32p Eaddy
 * o Now addBreakpoint only supplies the jp and adviceMethod
 * 
 * 2     4/02/06 4:34p Asv2105
 * Added ability for BreakpointWeaver to pass MethodInfo to the
 * coordinator
 * 
 * Adjusted ICoordinator, IEventListener interfaces to match reality
 * 
 * Added ability for Coordinator to call static methods when a breakpoint
 * fires and pass off to EventMgr for non-static methods
 * 
 * 1     3/15/06 2:32p Eaddy
 * o Added breakpoint callback
 */

using Phx.Aop.Joinpoints;
using System.Reflection;

namespace Phx.Aop
{
    public delegate void BreakpointWeaverCallback( IJoinpoint jp, 
                                                   uint lineToSetBreakpoint, 
                                                   MethodInfo method);
}
