//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/Pointcuts/Expressions/MultiplePointcutExpression.cs 4     2/26/06 9:12p Eaddy $
//
// Description:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/Pointcuts/Expressions/MultiplePointcutExpression.cs $
 * 
 * 4     2/26/06 9:12p Eaddy
 * o Now supports joinpoint matching
 * o Changed tabs to 3 spaces to conform with MS standard
 * 
 * 3     2/26/06 7:48p Eaddy
 * 
 * 2     2/24/06 8:17p Eaddy
 * o Initial checkin
 */

using Phx.Aop.Joinpoints;

namespace Phx.Aop.Pointcuts
{
   public class MultiplePointcutExpression : PointcutExpression
   {
      public PointcutExpression[] exprs;

      public MultiplePointcutExpression(params PointcutExpression[] exprs)
      {
         this.exprs = exprs;
      }

      public override PointcutExpression parse(string expr)
      {
         throw new System.Exception("The method or operation is not implemented.");
      }

      public override bool innerMatches(PointcutExpression rhs)
      {
         if (rhs == null)
            return false;

         MultiplePointcutExpression rhs2 = rhs as MultiplePointcutExpression;
         return rhs2 == null ? false : innerMatches(rhs2);
      }

      public override bool innerMatches(string rhs)
      {
         throw new System.Exception("The method or operation is not implemented.");
      }

      public override bool innerMatches(IJoinpoint rhs)
      {
         throw new System.Exception("The method or operation is not implemented.");
      }

      public bool innerMatches(MultiplePointcutExpression rhs)
      {
         if (rhs == null)
            return false;
         else if (exprs == rhs.exprs)
            return true;
         else if (exprs == null || rhs.exprs == null)
            return false;
         else if (exprs.Length != rhs.exprs.Length)
            return false;
         else
         {
            for (int i = 0; i < exprs.Length; ++i)
            {
               if (!exprs[i].innerMatches(rhs.exprs[i]))
                  return false;
            }

            return true;
         }
      }

      public override string innerToString()
      {
         System.Text.StringBuilder sb = new System.Text.StringBuilder();
         for (int i = 0; exprs != null && i < exprs.Length; ++i)
         {
            if (i != 0)
               sb.Append(' ');

            sb.Append(exprs[i].ToString());
         }

         return sb.ToString();
      }
   }
}
