//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/Pointcuts/SetPointcutExpression.cs 1     2/26/06 10:07p Eaddy $
//
// Description:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/Pointcuts/SetPointcutExpression.cs $
 * 
 * 1     2/26/06 10:07p Eaddy
 */

using System.Text.RegularExpressions;

using Dbg = System.Diagnostics.Debug;

using Phx.Aop.Joinpoints;

namespace Phx.Aop.Pointcuts
{
   /// <summary>
   /// get(* *.*)
   /// </summary>
   public class SetPointcutExpression : SignatureExpression, IPointcutDesignator
   {
      public SetPointcutExpression()
         : base(JoinpointType.SET)
      { }

      static public void register()
      {
         PointcutFactory.registerPointcutDesignator(new SetPointcutExpression());
      }

      public override string Name { get { return "set"; } }

      public PointcutExpression create()
      {
         return new SetPointcutExpression();
      }

      public override bool innerMatches(PointcutExpression rhs)
      {
         if (rhs == null)
            return false;

         SetPointcutExpression expRhs = rhs as SetPointcutExpression;
         return expRhs == null ? false : innerMatches(expRhs);
      }
   }
}
