//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Morph/Aop/PhxAdvice.cs 7     5/24/06 8:56a Eaddy $
//
// Description:
//
// See:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Morph/Aop/PhxAdvice.cs $
 * 
 * 7     5/24/06 8:56a Eaddy
 * o Changed file names but forgot to change class
 * names
 * 
 * 6     5/05/06 6:18p Eaddy
 * o Did some renaming to improve clarity
 * o Can now list current advice and enable/disable (although
 * enable/disable doesn't actually work yet)
 * 
 * 5     5/03/06 12:29a Eaddy
 * o Now base class keeps track of where advice has been applied
 * 
 * 4     3/15/06 1:19p Eaddy
 * o Added Applied flag
 * 
 * 3     3/03/06 3:34p Eaddy
 * o Name change
 * 
 * 2     3/03/06 2:57p Asv2105
 * Refactored so all classes refer to base class of MethodWeaver rather
 * than MethodEditor, and create new instances through
 * MethodWeaverFactory.
 * 
 * 1     3/01/06 2:17a Eaddy
 * o Now uses Phx.Aop library for pointcuts, advice and joinpoint matching
 */

using System;

using Phx.Aop.Attributes;
using Phx.Morph.Editors;

namespace Phx.Aop
{
   public class PhxAdvice : Advice
   {
      MethodEditor adviceMethodWeaver = null;

      public PhxAdvice(AdviceAttribute attr)
         : base(attr)
      { }

      public MethodEditor AdviceMethodWeaver
      {
         get 
         {
            return adviceMethodWeaver;
         }
         set
         {
            adviceMethodWeaver = value;
            adviceMethod = adviceMethodWeaver.ToString();
         }
      }
   }
}
