//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Morph/Attributes/AttributeHandlerRegistry.cs 3     5/24/06 9:53p Eaddy $
//
// Description:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Morph/Attributes/AttributeHandlerRegistry.cs $
 * 
 * 3     5/24/06 9:53p Eaddy
 * o Better diagnostics when the ctor param list for the inner
 * attribute doesn't match any ctor
 * 
 * 2     3/15/06 1:18p Eaddy
 * o Changed message
 * 
 * 1     2/24/06 8:22p Eaddy
 */

using System;
using System.Collections.Generic;

using Phx.Aop.Attributes;

namespace Phx.Morph.Attributes
{
   public interface IAttributeHandler
   {
      string AttributeName { get; }
      IExtensionAttribute Create(   Phx.Syms.AttrSym attrSym,
                                    System.Type attrType,
                                    AttributeHelper helper);
   }

   public class AttributeHandlerRegistry
   {
      static List<IAttributeHandler> handlers = new List<IAttributeHandler>();

      static public void InitStatic()
      {
         handlers.Add(new Phx.Morph.Attributes.AddAttributeHandler());
         handlers.Add(new Phx.Morph.Attributes.AdviceAttributeHandler());
         handlers.Add(new Phx.Morph.Attributes.ExtendsAttributeHandler());
         handlers.Add(new Phx.Morph.Attributes.MorphExecAttributeHandler());
         handlers.Add(new Phx.Morph.Attributes.ReplaceAttributeHandler());
      }

      static public IAttributeHandler GetHandler(string attrName)
      {
         if (handlers.Count == 0)
         {
            Helpers.WriteError("No attribute handlers found!");
         }

         foreach (IAttributeHandler handler in handlers)
         {
            if (handler.AttributeName == attrName)
            {
               return handler;
            }
         }

         /*if (attrName.StartsWith("Phx.Aop.Attributes."))
         {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            bool first = true;
            foreach (IAttributeHandler handler in handlers)
            {
               if (!first)
                  sb.Append(", ");
               sb.Append(handler.AttributeName);
               first = false;
            }

            Helpers.WriteError("Unknown attribute: '" + attrName + "'.  Expected one of " + sb.ToString() + ".");
         }*/

         return null;
      }
   }
}
