using System;

using Phx.Aop;
using Phx.Aop.Attributes;

namespace MyExtNS
{
   [Extends("HelloNS.Hello")]
   public class MyExt
   {
      public bool b;

      [Add]
      public bool b2;

      public static bool b3;

      // BREAKS! (tries to access MyExt.b which isn't in Hello)

      //[Add]
      //public bool PropB
      //{
      //	set { b = value; }
      //}

      [Add]
      public bool PropB2
      {
         get { return b2; }
         set { b2 = value; }
      }

      public MyExt()
      {
         b2 = true;
      }

      public MyExt(bool c)
      {
         b2 = c;
      }

      [Add]
      public float Int2Float(int i)
      {

         // Test accessing TypeRefs and MemberRefs
         MyExt obj = new MyExt();

         // BREAKS! (tries to access Hello.b2 not MyExt.b2)
         //obj.b2 = true;

         obj.b = true;

         // Test adding strings to the string table
         string str = "heyMan";

         // Assign imported field

         // BREAKS! (this ptr incorrect)
         //b2 = false;

         // BREAKS! (incorrect static member ref)
         //b3 = false;

         return i;
      }

      [Advice(AdviceType.before, "call([HelloTest] * *.*(..))")]
      static public void TraceHelloTest([Signature] string signature, 
                                        [SourceLocationAttribute.FileName] string fileName, 
                                        [SourceLocationAttribute.Line] uint line)
      {
         System.Console.WriteLine("Method '{0}' has a HelloTest attribute [File:{1}, Line:{2}].", 
            signature, fileName, line);
      }

      [Advice(AdviceType.before, "call([HelloTest] * *.*(..))")]
      static public void TraceHelloTest2([Signature] string signature, 
                                        [SourceLocationAttribute.FileName] string fileName, 
                                        [SourceLocationAttribute.Line] uint line)
      {
         System.Console.WriteLine("Method '{0}' has a HelloTest attribute [File:{1}, Line:{2}].", 
            signature, fileName, line);
      }
   }
}


