public class DepthFirstVisitor : NodeVisitor
{
   virtual public void visit(Node node)
   {
      foreach(Node childNode in node)
      {
         childNode.accept(this);
      }
   }

   virtual public void visit(BooleanExpression boolExprNode)
   {
      visit(boolExprNode as Node);
   }

   virtual public void visit(WhileLoopNode whileLoopNode)
   {
      if (whileLoopNode.Condition != null)
         whileLoopNode.Condition.accept(this);

      if (whileLoopNode.Body != null)
         whileLoopNode.Body.accept(this);
   }

   virtual public void visit(IfThenNode ifThenNode)
   {
      if (ifThenNode.Condition != null)
         ifThenNode.Condition.accept(this);

      if (ifThenNode.ThenBranch != null)
         ifThenNode.ThenBranch.accept(this);

      if (ifThenNode.ElseBranch != null)
         ifThenNode.ElseBranch.accept(this);
   }
}
