using System;
using System.Collections;

public class Node
{
   ArrayList children = new ArrayList();

   public void AddChild(Node child)
   {
      children.Add(child);
   }

   public int ChildCount
   {
      get { return children.Count; }
   }

   public Node GetChild(int i)
   {
      return children[i] as Node;
   }

   public void SetChild(int i, Node value)
   {
      children[i] = value;
   }
}

public class BooleanExpression : Node
{
}

public class WhileLoopNode : Node
{
   public WhileLoopNode(BooleanExpression condition, Node body)
   {
      AddChild(condition);
      AddChild(body);
   }

   public BooleanExpression Condition
   {
      get { return GetChild(0) as BooleanExpression; }
      set { SetChild(0, value); }
   }

   public Node Body
   {
      get { return GetChild(1) as Node; }
      set { SetChild(1, value); }
   }
}

public class IfThenNode : Node
{
   public IfThenNode(BooleanExpression condition,
         Node thenBranch,
         Node elseBranch)
   {
      AddChild(condition);
      AddChild(thenBranch);
      AddChild(elseBranch);
   }

   public IfThenNode(BooleanExpression condition,
         Node thenBranch)
      : this(condition, thenBranch, null)
   {
   }

   public BooleanExpression Condition
   {
      get { return GetChild(0) as BooleanExpression; }
      set { SetChild(0, value); }
   }

   public Node ThenBranch
   {
      get { return GetChild(1); }
      set { SetChild(1, value); }
   }

   public Node ElseBranch
   {
      get { return GetChild(2); }
      set { SetChild(2, value); }
   }
}
