using Phx.Aop.Attributes;

[Extends("Node")]
public class NodeExt
{
   [This]
   Node _this;

   [Add]
   virtual public void accept(NodeVisitor visitor)
   {
      visitor.visit(_this);
   }
}

[Extends("BooleanExpression")]
public class BooleanExpressionExt
{
   [This]
   BooleanExpression _this;

   [Add(IsOverride = true)]
   public void accept(NodeVisitor visitor)
   {
      visitor.visit(_this);
   }
}

[Extends("WhileLoopNode")]
public class WhileLoopNodeExt
{
   [This]
   WhileLoopNode _this;

   [Add(IsOverride = true)]
   public void accept(NodeVisitor visitor)
   {
      visitor.visit(_this);
   }
}

[Extends("IfThenNode")]
public class IfThenNodeExt
{
   [This]
   IfThenNode _this;

   [Add(IsOverride = true)]
   public void accept(NodeVisitor visitor)
   {
      visitor.visit(_this);
   }
}
