using Phx.Aop;
using Phx.Aop.Attributes;

public class PreventerAspect
{
	[Advice(AdviceType.before, "call(* System.IO.FileStream.new(..))")]
	[Advice(AdviceType.before, "call(* System.IO.File.Open(..))")]
	[Advice(AdviceType.before, "call(* System.IO.FileInfo.Open(..))")]
	[Advice(AdviceType.before, "call(* System.IO.StreamReader.new(string))")]
	public static void invalidAction([SignatureAttribute] string signature)
        {
		System.Console.Error.WriteLine("Security exception: Access to restricted method {0}.  Aborting.", signature);
		System.Environment.Exit(1);
	}
}