using Phx.Aop;
using Phx.Aop.Attributes;

public class LogReflectionAspect
{
   static System.ConsoleColor colorToUse = System.ConsoleColor.Green;

   [Advice(AdviceType.before, "call(* System.Reflection.*.*(..))")]
   public static void logMethodCall(
            [Signature] string signature,
            [SourceLocationAttribute.WithinSignature] string withinSignature,
            [SourceLocationAttribute.FilePath] string fileName,
            [SourceLocationAttribute.Line] uint line)
   {
      System.ConsoleColor fc = System.Console.ForegroundColor;
      System.Console.ForegroundColor = colorToUse;

      try
      {
         System.Console.WriteLine("\t{0}() called {1}(). [{2},{3}]",
            withinSignature, signature, fileName, line);
      }
      finally
      {
         System.Console.ForegroundColor = fc;
      }
   }
}
