using System;
using Phx.Aop;
using Phx.Aop.Attributes;

public class TraceAspect
{
   static System.ConsoleColor colorToUse = System.ConsoleColor.Green;

   [Advice(AdviceType.before, "execution([Trace] * *.*(..))")]
   public static void logMethodExecution(
            [Signature] string signature,
            [SourceLocationAttribute.FilePath] string fileName,
            [SourceLocationAttribute.Line] uint line)
   {
      System.ConsoleColor fc = System.Console.ForegroundColor;
      System.Console.ForegroundColor = colorToUse;

      try
      {
         System.Console.WriteLine("Entering {0}(). [{1},{2}]",
            signature, fileName, line);
      }
      finally
      {
         System.Console.ForegroundColor = fc;
      }
   }
}
