using System;
using Phx.Aop.Attributes;

public class SimpleDraw : ISimpleDraw
{
   public Shape[] s;

   Random random = new Random();

   int[] x_move_pts = { 2,  6,  6,  1, 2, -4, 2, 11, 10, 1 };
   int[] y_move_pts = { 5, 10, 14, 13, 2, 15, 0, -3, -8, 2 };

   [Statement(19, "LogAttribute", Sev.Info, "Creating a line")]
   public SimpleDraw()
   {
      s = new Shape[3];
      s[0] = new Point(10, 10);
      s[1] = new Point(5, 5);
      s[2] = new Line(new Point(1, 9), new Point(9, 1));
   }

   public Shape[] Shapes
   {
      get { return s; }
   }

   private int rnd()
   {
      return ((int) (random.Next() % 10)) - 5;
   }

   private void randomMove()
   {
      s[(int) (random.Next() % s.Length)].moveBy(rnd(), rnd());
   }

   public void runDraw()
   {
      int cur = 0;
      for (int i = 0; i < 10; i++)
      {
         #if USE_RANDOM
         randomMove();
         #else
         s[cur++ % s.Length].moveBy(x_move_pts[i], y_move_pts[i]);
         #endif
      }
   }

   public static void Main()
   {
      Console.WriteLine("-------------------------------");
      Console.WriteLine("       Simple Draw Sample      ");
      Console.WriteLine("-------------------------------");

      SimpleDraw sd = new SimpleDraw();
      sd.runDraw();

      System.Type forceLoad1 = typeof(DisplayUpdatingAspect);
      //System.Type forceLoad2 = typeof(LogAspect);
   }

}
