///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Common/AssemblyHelper/AssemblyDiff.h 4     4/22/06 12:35p Eaddy $
//
//    File name:	AssemblyDiff.h
//   Created By:	Marc Eaddy
//   Created on:	10/24/04
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Common/AssemblyHelper/AssemblyDiff.h $
 * 
 * 4     4/22/06 12:35p Eaddy
 * o Adding support for using the Debugger API to query for the current
 * metadata and IL
 * 
 * 3     4/18/06 11:43p Eaddy
 * o Changed back to the old emit algorithm
 * o Improved diagnostics
 * o No longer outputs empty dil or dmeta files
 * 
 * 2     4/11/06 11:12p Eaddy
 * o Dynamic binary updating proof-of-concept works!
 * 
 * 1     3/16/06 1:53a Eaddy
 * 
 * 1     3/16/06 1:49a Eaddy
 * 
 * 6     5/28/05 1:49p Eaddy
 * o Changed copyright
 *
 * Revision 1.1  2004/10/25 01:03:48  me133
 * o Method IL comparison is now complete and correct
 */

#ifndef INCLUDED_ASSEMBLY_DIFF_H
#define INCLUDED_ASSEMBLY_DIFF_H

#include "MethodInfo.h"			// CMethodInfo

#include <cor.h>				// Needed to compile corprof.h!!
#include <corprof.h>			// ICorProfilerCallback
#include <cordebug.h>           // ICorDebugModule

#include <hash_map>				// STDEXT hash_map<>

typedef stdext::hash_map<mdMethodDef, CMethodInfo>	TypeMapMethodInfo;

HRESULT CreateUpdatePatches(	/*[in]*/ ICorProfilerInfo* piProfInfo,
								/*[in]*/ ModuleID moduleIDOrig,
								/*[in]*/ IMetaDataImport* piImportNewModule,
								/*[in]*/ LPCBYTE pbLoadAddressNewModule,
								/*[in]*/ bool bFirstTime,
								/*[in,out]*/ TypeMapMethodInfo* pmapChangedFunctions);

HRESULT CreateUpdatePatches(	/*[in]*/ ICorDebugModule* piunkActiveCorModule,
                                /*[in]*/ IMetaDataImport* piImportOrig,
								/*[in]*/ LPCBYTE pbLoadAddressOrigModule,
								/*[in]*/ bool bIsImageOrig, 
								/*[in]*/ ModuleID moduleIDOrig,
								/*[in]*/ IMetaDataImport* piImportNew,
								/*[in]*/ LPCBYTE pbLoadAddressNewModule,
								/*[in]*/ ICorProfilerInfo* piProfInfo,
								/*[in]*/ IMetaDataEmit* spiMetaDataEmit,
								/*[in]*/ IMethodMalloc* spiMethodAlloc,
								/*[in]*/ bool bFirstTime,
								/*[in]*/ FILE* pfILDeltaFile,
								/*[in,out]*/ TypeMapMethodInfo* pmapChangedFunctions,
                                /*[in,out]*/ TypeListTokenMappings* plistNewOrReorderedTokens);

#endif // INCLUDED_ASSEMBLY_DIFF_H
